// EAPI_WINCEDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Eapi.h"
#include "Eapi_Seco.h"
#include "EAPI_WINCE.h"
#include "EAPI_WINCEDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define MASK_BIT0 0x01
#define MASK_BIT1 0x02
#define MASK_BIT2 0x04
#define MASK_BIT3 0x08
#define MASK_BIT4 0x10
#define MASK_BIT5 0x20
#define MASK_BIT6 0x40
#define MASK_BIT7 0x80

BOOL bTriggerFlag = FALSE;
unsigned char CarrierBoard = CARRIER_NONE; 

// CEAPI_ExeDlg dialog

CEAPI_ExeDlg::CEAPI_ExeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEAPI_ExeDlg::IDD, pParent)
	, m_Timeout_Expressed(0)
	, m_Delay_Expressed(0)
	, m_WDT_Mode(0)
	, m_Trigger_SW_HW(0)
	, m_BKL_Enable(0)
	, m_Reset(3000)
	, m_Delay(3000)
	, m_Event(0)
	, m_Fan_Cycle(0)
	, m_Fan_Duty(0)
	, m_Data_String(_T("00"))
	, m_DevAdd_String(_T("00"))
	, m_Reg_String(_T("00"))
	, GPIO00_Level(FALSE)
	, GPIO01_Level(FALSE)
	, GPIO02_Level(FALSE)
	, GPIO03_Level(FALSE)
	, GPIO04_Level(FALSE)
	, GPIO05_Level(FALSE)
	, GPIO06_Level(FALSE)
	, GPIO07_Level(FALSE)
	, GPIO01_DIRECTION(FALSE)
	, GPIO02_DIRECTION(FALSE)
	, GPIO03_DIRECTION(FALSE)
	, GPIO04_DIRECTION(FALSE)
	, GPIO05_DIRECTION(FALSE)
	, GPIO06_DIRECTION(FALSE)
	, GPIO07_DIRECTION(FALSE)
	, GPIO08_DIRECTION(FALSE)
	, m_GPIO_Serial(0)
	, m_pITX_Carrier(0)
	, m_I2C_Mode(0)
	, m_Storage_num_byte_to_read(0)
	, m_NVS_Data(_T(""))
	, m_NVS_Address(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEAPI_ExeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_RADIO5, m_Timeout_Expressed);
	DDX_Radio(pDX, IDC_RADIO7, m_Delay_Expressed);
	DDX_Radio(pDX, IDC_RADIO11, m_WDT_Mode);
	DDX_Radio(pDX, IDC_RADIO31, m_Trigger_SW_HW);
	DDX_Check(pDX, IDC_BACKL_ENA, m_BKL_Enable);
	DDX_Text(pDX, IDC_EDIT1, m_Fan_Cycle);
	DDX_Text(pDX, IDC_EDIT2, m_Fan_Duty);
	DDX_Text(pDX, IDC_EDIT4, m_DevAdd_String);
	DDX_Text(pDX, IDC_EDIT10, m_NVS_Address);
	DDX_Text(pDX, IDC_EDIT5, m_Data_String);
	DDX_Text(pDX, IDC_EDIT9, m_NVS_Data);
	DDX_Text(pDX, IDC_EDIT3, m_Reg_String);
	DDX_Control(pDX, IDC_LIB_REV, m_Library_Rev);
	DDX_Control(pDX, IDC_MANUF, m_Manufacturer);
	DDX_Control(pDX, IDC_PRODUCT, m_Product_Name);
	DDX_Control(pDX, IDC_SERIA_NUM, m_Serial_Number);
	DDX_Control(pDX, IDC_BOOT_COUNT, m_Boot_Conter);
	DDX_Control(pDX, IDC_BIOS_REV, m_Bios_revision);
	DDX_Control(pDX, IDC_PLATFORM_REV, m_Platform_Rev);
	DDX_Control(pDX, IDC_PLATFORM_TYPE, m_Platform_type);
	DDX_Control(pDX, IDC_HW_REV, m_HW_revision);
	DDX_Control(pDX, IDC_TEMPERATURE1, m_Temperature1);
	DDX_Control(pDX, IDC_TEMPERATURE2, m_Temperature2);
	DDX_Control(pDX, IDC_FAN_RPS, m_Fan_RPM);
	DDX_Control(pDX, IDC_FAN_RPS2, m_Fan_RPM2);
	DDX_Control(pDX, IDC_BACKLIGHT_PERCENT, m_label_backlight);
	DDX_Control(pDX, IDC_SLIDER_BACKLIGHT, m_slider_backlight);
	DDX_Control(pDX, IDC_SPEC_VERS, m_Spec_version);
	DDX_Text(pDX, IDC_EDIT6, m_Reset);
	DDX_Text(pDX, IDC_EDIT7, m_Delay);
	DDX_Text(pDX, IDC_EDIT12, m_Event);
	DDX_Radio(pDX, IDC_RADIO10, m_GPIO_Serial);
	DDX_Check(pDX, IDC_CHECK3, GPIO00_Level);
	DDX_Check(pDX, IDC_CHECK4, GPIO01_Level);
	DDX_Check(pDX, IDC_CHECK5, GPIO02_Level);
	DDX_Check(pDX, IDC_CHECK6, GPIO03_Level);
	DDX_Check(pDX, IDC_CHECK7, GPIO04_Level);
	DDX_Check(pDX, IDC_CHECK8, GPIO05_Level);
	DDX_Check(pDX, IDC_CHECK9, GPIO06_Level);
	DDX_Check(pDX, IDC_CHECK10, GPIO07_Level);
	DDX_Check(pDX, IDC_CHECK11, GPIO01_DIRECTION);
	DDX_Check(pDX, IDC_CHECK12, GPIO02_DIRECTION);
	DDX_Check(pDX, IDC_CHECK13, GPIO03_DIRECTION);
	DDX_Check(pDX, IDC_CHECK14, GPIO04_DIRECTION);
	DDX_Check(pDX, IDC_CHECK15, GPIO05_DIRECTION);
	DDX_Check(pDX, IDC_CHECK16, GPIO06_DIRECTION);
	DDX_Check(pDX, IDC_CHECK17, GPIO07_DIRECTION);
	DDX_Check(pDX, IDC_CHECK18, GPIO08_DIRECTION);
	DDX_Radio(pDX, IDC_PITX_NONE, m_pITX_Carrier);
	DDX_Text(pDX, IDC_EDIT11, m_Storage_num_byte_to_read);
	DDX_Control(pDX, IDC_VCORE, m_VCore_Voltage);
	DDX_Control(pDX, IDC_2V5, m_2V5_Voltage);
	DDX_Control(pDX, IDC_3V3, m_3V3_Voltage);
	DDX_Control(pDX, IDC_VBAT, m_VBat_Voltage);
	DDX_Control(pDX, IDC_5V, m_5V_Voltage);
	DDX_Control(pDX, IDC_5VSB, m_5VSB_Voltage);
	DDX_Control(pDX, IDC_12V, m_12V_Voltage);
	DDX_Radio(pDX, IDC_I2C_EXT, m_I2C_Mode);
}

BEGIN_MESSAGE_MAP(CEAPI_ExeDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_GET_CYCLE, &CEAPI_ExeDlg::OnBnClickedGetCycle)
	ON_BN_CLICKED(IDC_SET_CYCLE, &CEAPI_ExeDlg::OnBnClickedSetCycle)
	ON_BN_CLICKED(IDC_GET_DUTY, &CEAPI_ExeDlg::OnBnClickedGetDutyCycle)
	ON_BN_CLICKED(IDC_SET_DUTY, &CEAPI_ExeDlg::OnBnClickedSetDutyCycle)
	ON_BN_CLICKED(IDC_ENABLE_FAN, &CEAPI_ExeDlg::OnBnClickedEnableFAN)
	ON_BN_CLICKED(IDC_DISABLE_FAN, &CEAPI_ExeDlg::OnBnClickedDisableFAN)
	ON_BN_CLICKED(IDC_READ_BYTE, &CEAPI_ExeDlg::OnBnClickedI2cRead)
	ON_BN_CLICKED(IDC_WRITE_BYTE, &CEAPI_ExeDlg::OnBnClickedI2cWrite)
	ON_BN_CLICKED(IDC_READ_REG, &CEAPI_ExeDlg::OnBnClickedI2cReadReg)
	ON_BN_CLICKED(IDC_WRITE_REG, &CEAPI_ExeDlg::OnBnClickedI2cWriteReg)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_ENABLE_WDT, &CEAPI_ExeDlg::OnBnClickedEnableWdt)
	ON_BN_CLICKED(IDC_DISABLE_WDT, &CEAPI_ExeDlg::OnBnClickedDisableWdt)
	ON_BN_CLICKED(IDC_START_TRIG, &CEAPI_ExeDlg::OnBnClickedStartTrig)
	ON_BN_CLICKED(IDC_STOP_TRIG, &CEAPI_ExeDlg::OnBnClickedStopTrig)
	ON_BN_CLICKED(IDC_RADIO10, &CEAPI_ExeDlg::OnBnClickedRadio10)
	ON_BN_CLICKED(IDC_RADIO15, &CEAPI_ExeDlg::OnBnClickedRadio15)
	ON_BN_CLICKED(IDC_RADIO16, &CEAPI_ExeDlg::OnBnClickedRadio16)
	ON_BN_CLICKED(IDC_RADIO17, &CEAPI_ExeDlg::OnBnClickedRadio17)
	ON_BN_CLICKED(IDC_CHECK3, &CEAPI_ExeDlg::OnBnClickedGPIO01)
	ON_BN_CLICKED(IDC_CHECK4, &CEAPI_ExeDlg::OnBnClickedGPIO02)
	ON_BN_CLICKED(IDC_CHECK5, &CEAPI_ExeDlg::OnBnClickedGPIO03)
	ON_BN_CLICKED(IDC_CHECK6, &CEAPI_ExeDlg::OnBnClickedGPIO04)
	ON_BN_CLICKED(IDC_CHECK7, &CEAPI_ExeDlg::OnBnClickedGPIO17)
	ON_BN_CLICKED(IDC_CHECK8, &CEAPI_ExeDlg::OnBnClickedGPIO20)
	ON_BN_CLICKED(IDC_CHECK9, &CEAPI_ExeDlg::OnBnClickedGPIO21)
	ON_BN_CLICKED(IDC_CHECK10, &CEAPI_ExeDlg::OnBnClickedGPIO22)
	ON_BN_CLICKED(IDC_CHECK11, &CEAPI_ExeDlg::OnBnClickedCheck11)
	ON_BN_CLICKED(IDC_CHECK12, &CEAPI_ExeDlg::OnBnClickedCheck12)
	ON_BN_CLICKED(IDC_CHECK13, &CEAPI_ExeDlg::OnBnClickedCheck13)
	ON_BN_CLICKED(IDC_CHECK14, &CEAPI_ExeDlg::OnBnClickedCheck14)
	ON_BN_CLICKED(IDC_CHECK15, &CEAPI_ExeDlg::OnBnClickedCheck15)
	ON_BN_CLICKED(IDC_CHECK16, &CEAPI_ExeDlg::OnBnClickedCheck16)
	ON_BN_CLICKED(IDC_CHECK17, &CEAPI_ExeDlg::OnBnClickedCheck17)
	ON_BN_CLICKED(IDC_CHECK18, &CEAPI_ExeDlg::OnBnClickedCheck18)
	ON_BN_CLICKED(IDC_READ_STORAGE, &CEAPI_ExeDlg::OnBnClicked_NVS_Read)
	ON_BN_CLICKED(IDC_WRITE_STORAGE, &CEAPI_ExeDlg::OnBnClicked_NVS_Write)
	ON_BN_CLICKED(IDC_BACKL_ENA, &CEAPI_ExeDlg::OnBnClickedBacklEna)
	ON_BN_CLICKED(IDC_PITX_NONE, &CEAPI_ExeDlg::OnBnClickedPitxNone)
	ON_BN_CLICKED(IDC_PITX_799, &CEAPI_ExeDlg::OnBnClickedPitx799)
	ON_BN_CLICKED(IDC_PITX_901, &CEAPI_ExeDlg::OnBnClickedPitx901)
	ON_BN_CLICKED(IDC_0A42, &CEAPI_ExeDlg::OnBnClickedCarrA42)
	ON_BN_CLICKED(IDC_0A19, &CEAPI_ExeDlg::OnBnClickedCarrA19)
	ON_BN_CLICKED(IDC_GPIO_REFRESH, &CEAPI_ExeDlg::OnBnClickedGpioRefresh)
	ON_BN_CLICKED(IDC_ENABLE_WDT2, &CEAPI_ExeDlg::OnBnClickedEnableWDTCustom)
END_MESSAGE_MAP()


// CEAPI_ExeDlg message handlers

BOOL CEAPI_ExeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: aggiungere qui inizializzazione aggiuntiva.

	//EApiEnableDebugLog(TRUE);

	// --------------------------------------------------------------
	EApiStatus_t Ret = EApiLibInitialize();

	if(Ret != EAPI_STATUS_SUCCESS)
		MessageBox(_T("EApiLibInitalize  ERROR"), 0, 0);
	// --------------------------------------------------------------

	GetDlgItem(IDC_LEVEL_GPIO01)->EnableWindow(FALSE);
	GetDlgItem(IDC_LEVEL_GPIO02)->EnableWindow(FALSE);
	GetDlgItem(IDC_LEVEL_GPIO03)->EnableWindow(FALSE);
	GetDlgItem(IDC_LEVEL_GPIO04)->EnableWindow(FALSE);
	GetDlgItem(IDC_LEVEL_GPIO05)->EnableWindow(FALSE);
	GetDlgItem(IDC_LEVEL_GPIO06)->EnableWindow(FALSE);
	GetDlgItem(IDC_LEVEL_GPIO07)->EnableWindow(FALSE);
	GetDlgItem(IDC_LEVEL_GPIO08)->EnableWindow(FALSE);

	GetDlgItem(IDC_DIRECTION_GPIO01)->EnableWindow(FALSE);
	GetDlgItem(IDC_DIRECTION_GPIO02)->EnableWindow(FALSE);
	GetDlgItem(IDC_DIRECTION_GPIO03)->EnableWindow(FALSE);
	GetDlgItem(IDC_DIRECTION_GPIO04)->EnableWindow(FALSE);
	GetDlgItem(IDC_DIRECTION_GPIO05)->EnableWindow(FALSE);
	GetDlgItem(IDC_DIRECTION_GPIO06)->EnableWindow(FALSE);
	GetDlgItem(IDC_DIRECTION_GPIO07)->EnableWindow(FALSE);
	GetDlgItem(IDC_DIRECTION_GPIO08)->EnableWindow(FALSE);

	GetDlgItem(IDC_RS232)->EnableWindow(FALSE);
	GetDlgItem(IDC_RS422)->EnableWindow(FALSE);
	GetDlgItem(IDC_RS485RX)->EnableWindow(FALSE);
	GetDlgItem(IDC_RS485TX)->EnableWindow(FALSE);
	
	OnBnClickedPitxNone();

	bTriggerFlag = true;

	uint32_t MaxLen = EAPI_MAX_LEN_STRING;

	wchar_t msg[1024];
	wchar_t msg1[1024];
	DWORD ThreadId;
	uint32_t LibraryRevision;
	uint32_t Platform_Rev;
	uint32_t Spec_version;
	uint32_t BootCounter;
	char Platform_Type[EAPI_MAX_LEN_STRING];
	char HW_Revision[EAPI_MAX_LEN_STRING];
	char Manufacturer[EAPI_MAX_LEN_STRING];
	char BoardName[EAPI_MAX_LEN_STRING];
	char SerialNum[EAPI_MAX_LEN_STRING];
	char BiosRev[EAPI_MAX_LEN_STRING];
	unsigned char MajorRev = 0;
	unsigned char MinorRev = 0;
	unsigned short BuildRev = 0;
	uint32_t valueFREQ = 0;
	uint32_t Bitmask = 0x000000FF;
	uint32_t Direction = 0;
	uint32_t Level = 0;
	uint32_t valueBL;
	uint32_t Temperature = 0;
	uint32_t RPM = 0;
	uint32_t MaxBlkLen = 0;
	uint32_t Mon_VCore = 0;
	uint32_t Mon_2V5 = 0;
	uint32_t Mon_3V3 = 0;
	uint32_t Mon_VBat = 0;
	uint32_t Mon_5V = 0;
	uint32_t Mon_5VSB = 0;
	uint32_t Mon_12V = 0;

	uint8_t Val_GPIO_SERIAL_MODE;

	GetDlgItem(IDC_START_TRIG)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP_TRIG)->EnableWindow(FALSE);
	GetDlgItem(IDC_ENABLE_WDT)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENABLE_WDT_CUSTOM)->EnableWindow(TRUE);
	GetDlgItem(IDC_DISABLE_WDT)->EnableWindow(FALSE);
	GetDlgItem(IDC_DISABLE_FAN)->EnableWindow(FALSE);
	
	//// ------------------------------ Serial Port Configuration ------------------------------------

	EApiGPIOGetSerialCfg(&Val_GPIO_SERIAL_MODE);

	switch(Val_GPIO_SERIAL_MODE)
	{
		case GPIO_SERIAL_MODE_RS232:
			m_GPIO_Serial = 0;
			break;
		case GPIO_SERIAL_MODE_RS422:
			m_GPIO_Serial = 1;
			break;
		case GPIO_SERIAL_MODE_RS485TX:
			m_GPIO_Serial = 2;
			break;
		case GPIO_SERIAL_MODE_RS485RX:
			m_GPIO_Serial = 3;
			break;
		default:
			break;
	}

	//// ------------------------------ Backlight and LCD Frequency Control ------------------------------------
	m_slider_backlight.SetRange(0,EAPI_BACKLIGHT_SET_BRIGHTEST);
	EApiVgaGetBacklightBrightness(EAPI_ID_BACKLIGHT_1, &valueBL);

	m_slider_backlight.SetPos(valueBL);
	wsprintf(msg,_T("%d %%"), valueBL);
	m_label_backlight.SetWindowText(msg);

	GetDlgItem(IDC_START_TRIG)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP_TRIG)->EnableWindow(FALSE);
	GetDlgItem(IDC_ENABLE_WDT)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENABLE_WDT_CUSTOM)->EnableWindow(TRUE);
	GetDlgItem(IDC_DISABLE_WDT)->EnableWindow(FALSE);
	GetDlgItem(IDC_DISABLE_FAN)->EnableWindow(FALSE);

	// ------------------------------ Library Version ------------------------------------

	Ret = EApiBoardGetValue(EAPI_ID_BOARD_LIB_VERSION_VAL, &LibraryRevision);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		MajorRev = (unsigned char)((LibraryRevision & 0xFF000000) >> 24);
		MinorRev = (unsigned char)((LibraryRevision & 0x00FF0000) >> 16);
		BuildRev = (unsigned short)(LibraryRevision & 0x0000FFFF);

		wsprintf(msg,_T("v.%d.%d.%d"), MajorRev, MinorRev, BuildRev);
		m_Library_Rev.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_Library_Rev.SetWindowText(_T("Not Supported"));
	}
	else
	{
		m_Library_Rev.SetWindowText(_T("Error"));
	}
	// ------------------------------ Specific version ------------------------------------
	Ret = EApiBoardGetValue(EAPI_ID_GET_EAPI_SPEC_VERSION, &Spec_version);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		MajorRev = (unsigned char)((Spec_version & 0xFF000000) >> 24);
		MinorRev = (unsigned char)((Spec_version & 0x00FF0000) >> 16);
		BuildRev = (unsigned short)(Spec_version & 0x0000FFFF);

		wsprintf(msg,_T("v.%d.%d.%d"), MajorRev, MinorRev, BuildRev);
		m_Spec_version.SetWindowText(msg);
	}
	else
	{
		m_Spec_version.SetWindowText(_T("Error"));
	}

	// ------------------------------ Manufacturer ------------------------------------
	MaxLen = EAPI_MAX_LEN_STRING;
	Ret = EApiBoardGetStringA(EAPI_ID_BOARD_MANUFACTURER_STR, Manufacturer, &MaxLen);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, Manufacturer, -1, msg1, _MAX_PATH );
		wsprintf(msg,_T("%s"), msg1);
		m_Manufacturer.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_Manufacturer.SetWindowText(_T("Not Supported"));
	}
	else
	{
		m_Manufacturer.SetWindowText(_T("Error"));
	}
	// ------------------------------ Board Name ------------------------------------
	MaxLen = EAPI_MAX_LEN_STRING;
	Ret = EApiBoardGetStringA(EAPI_ID_BOARD_NAME_STR, BoardName, &MaxLen);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, BoardName, -1, msg1, _MAX_PATH );
		wsprintf(msg,_T("%s"), msg1);
		m_Product_Name.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_Product_Name.SetWindowText(_T("Not Supported"));
	}
	else
	{
		m_Product_Name.SetWindowText(_T("Error"));
	}

	// ------------------------------ Serial Number ------------------------------------
	MaxLen = EAPI_MAX_LEN_STRING;
	Ret = EApiBoardGetStringA(EAPI_ID_BOARD_SERIAL_STR, SerialNum, &MaxLen);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, SerialNum, -1, msg1, _MAX_PATH );
		wsprintf(msg,_T("%s"), msg1);
		m_Serial_Number.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_Serial_Number.SetWindowText(_T("Not Supported"));
	}
	else
	{
		m_Serial_Number.SetWindowText(_T("Error"));
	}

	// ------------------------------ Boot Bounter ------------------------------------
	Ret = EApiBoardGetValue(EAPI_ID_BOARD_BOOT_COUNTER_VAL, &BootCounter);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		wsprintf(msg,_T("%d"), BootCounter);
		m_Boot_Conter.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_Boot_Conter.SetWindowText(_T("Not Supported"));
	}
	else
	{
		m_Boot_Conter.SetWindowText(_T("Error"));
	}

	// ------------------------------ BIOS Revision ------------------------------------
	MaxLen = EAPI_MAX_LEN_STRING;
	Ret = EApiBoardGetStringA(EAPI_ID_BOARD_BIOS_REVISION_STR, BiosRev, &MaxLen);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, BiosRev, -1, msg1, _MAX_PATH );
		wsprintf(msg,_T("%s"), msg1);
		m_Bios_revision.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_Bios_revision.SetWindowText(_T("Not Supported"));
	}
	else
	{
		m_Bios_revision.SetWindowText(_T("Error"));
	}

	// ------------------------------ HW Revision ------------------------------------
	MaxLen = EAPI_MAX_LEN_STRING;
	Ret = EApiBoardGetStringA(EAPI_ID_BOARD_HW_REVISION_STR, HW_Revision, &MaxLen);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, HW_Revision, -1, msg1, _MAX_PATH );
		wsprintf(msg,_T("%s"), msg1);
		m_HW_revision.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_HW_revision.SetWindowText(_T("Not Supported"));
	}
	else
	{
		m_HW_revision.SetWindowText(_T("Error"));
	}

	// ------------------------------ Platform Type ------------------------------------
	MaxLen = EAPI_MAX_LEN_STRING;
	Ret = EApiBoardGetStringA(EAPI_ID_BOARD_PLATFORM_TYPE_STR, Platform_Type, &MaxLen);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, Platform_Type, -1, msg1, _MAX_PATH );
		wsprintf(msg,_T("%s"), msg1);
		m_Platform_type.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_Platform_type.SetWindowText(_T("Not Supported"));
	}
	else
	{
		m_Platform_type.SetWindowText(_T("Error"));
	}

	// ------------------------------ Platform Revision ------------------------------------
	Ret = EApiBoardGetValue(EAPI_ID_BOARD_PLATFORM_REV_VAL, &Platform_Rev);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		MajorRev = (unsigned char)((Platform_Rev & 0xFF000000) >> 24);
		MinorRev = (unsigned char)((Platform_Rev & 0x00FF0000) >> 16);
		BuildRev = (unsigned short)(Platform_Rev & 0x0000FFFF);

		wsprintf(msg,_T("v.%d.%d.%d"), MajorRev, MinorRev, BuildRev);
		m_Platform_Rev.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_Platform_Rev.SetWindowText(_T("Not Supported"));
	}
	else
	{
		m_Platform_Rev.SetWindowText(_T("Error"));
	}

	// ---------------------------------- Temperature ---------------------------------------
	Ret = EApiBoardGetValue(EAPI_ID_HWMON_CPU_TEMP, &Temperature);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		wsprintf(msg,_T("%d (0.1K) %d (C)"), Temperature, (Temperature - 2731)/10);
		m_Temperature1.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_Temperature1.SetWindowText(TEXT("Not Supported"));
	}
	else
	{
		m_Temperature1.SetWindowText(TEXT("Error"));
	}

	Ret = EApiBoardGetValue(EAPI_ID_HWMON_CHIPSET_TEMP, &Temperature);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		wsprintf(msg,_T("%d (0.1K) %d (C)"), Temperature, (Temperature - 2731)/10);
		m_Temperature2.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_Temperature2.SetWindowText(_T("Not Supported"));
	}
	else
	{
		m_Temperature2.SetWindowText(_T("Error"));
	}

	// ---------------------------------- Fan RPM ---------------------------------------
	if(EApiBoardGetValue(EAPI_ID_HWMON_FAN_CPU, &RPM) == EAPI_STATUS_SUCCESS)
	{
		wsprintf(msg,_T("%d"), RPM);
		m_Fan_RPM.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_Fan_RPM.SetWindowText(_T("Not Supported"));
	}
	else
	{
		m_Fan_RPM.SetWindowText(_T("Error"));
	}

	// ---------------------------------- Fan RPM ---------------------------------------

	Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_VCORE, &Mon_VCore);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		wsprintf(msg, _T("%5.3fV"), ((float)Mon_VCore)/1000);
		m_VCore_Voltage.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_VCore_Voltage.SetWindowText(TEXT("Not Supported"));
	}
	else
	{
		m_VCore_Voltage.SetWindowText(TEXT("Error"));
	}
	
	Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_2V5, &Mon_2V5);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		wsprintf(msg, _T("%5.3fV"), ((float)Mon_2V5)/1000);
		m_2V5_Voltage.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_2V5_Voltage.SetWindowText(TEXT("Not Supported"));
	}
	else
	{
		m_2V5_Voltage.SetWindowText(TEXT("Error"));
	}	

	Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_3V3, &Mon_3V3);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		wsprintf(msg, _T("%5.3fV"), ((float)Mon_3V3)/1000);
		m_3V3_Voltage.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_3V3_Voltage.SetWindowText(TEXT("Not Supported"));
	}
	else
	{
		m_3V3_Voltage.SetWindowText(TEXT("Error"));
	}	

	Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_VBAT, &Mon_VBat);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		wsprintf(msg, _T("%5.3fV"), ((float)Mon_VBat)/1000);
		m_VBat_Voltage.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_VBat_Voltage.SetWindowText(TEXT("Not Supported"));
	}
	else
	{
		m_VBat_Voltage.SetWindowText(TEXT("Error"));
	}

	Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_5V, &Mon_5V);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		wsprintf(msg, _T("%5.3fV"), ((float)Mon_5V)/1000);
		m_5V_Voltage.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_5V_Voltage.SetWindowText(TEXT("Not Supported"));
	}
	else
	{
		m_5V_Voltage.SetWindowText(TEXT("Error"));
	}

	Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_5VSB, &Mon_5VSB);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		wsprintf(msg, _T("%5.3fV"), ((float)Mon_5VSB)/1000);
		m_5VSB_Voltage.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_5VSB_Voltage.SetWindowText(TEXT("Not Supported"));
	}
	else
	{
		m_5VSB_Voltage.SetWindowText(TEXT("Error"));
	}

	Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_12V, &Mon_12V);
	if(Ret == EAPI_STATUS_SUCCESS)
	{
		wsprintf(msg, _T("%5.3fV"), ((float)Mon_12V)/1000);
		m_12V_Voltage.SetWindowText(msg);
	}
	else if (Ret == EAPI_STATUS_UNSUPPORTED)
	{
		m_12V_Voltage.SetWindowText(TEXT("Not Supported"));
	}
	else
	{
		m_12V_Voltage.SetWindowText(TEXT("Error"));
	}

	// ---------------------------------- Fan RPM ---------------------------------------
	if(EApiBoardGetValue(EAPI_ID_HWMON_FAN_CPU, &RPM) == EAPI_STATUS_SUCCESS)
	{
		wsprintf(msg,_T("%d"), RPM);
		m_Fan_RPM.SetWindowText(msg);
	}
	else
	{
		m_Fan_RPM.SetWindowText(_T("Not Supported"));
	}

	// ---------------------------------- GPIO ---------------------------------------

	Ret = EApiGPIOGetDirection(EAPI_ID_GPIO_BANK00, Bitmask, &Direction);
	Ret = EApiGPIOGetLevel(EAPI_ID_GPIO_BANK00, Bitmask, &Level);

	(Direction	& 0x01)	? GPIO01_DIRECTION	= 1 : GPIO01_DIRECTION	= 0;
	(Level		& 0x01)	? GPIO00_Level		= 1	: GPIO00_Level		= 0;
	(Direction	& 0x02)	? GPIO02_DIRECTION	= 1 : GPIO02_DIRECTION	= 0;
	(Level		& 0x02)	? GPIO01_Level		= 1	: GPIO01_Level		= 0;
	(Direction	& 0x04)	? GPIO03_DIRECTION	= 1 : GPIO03_DIRECTION	= 0;
	(Level		& 0x04)	? GPIO02_Level		= 1	: GPIO02_Level		= 0;
	(Direction	& 0x08)	? GPIO04_DIRECTION	= 1 : GPIO04_DIRECTION	= 0;
	(Level		& 0x08)	? GPIO03_Level		= 1	: GPIO03_Level		= 0;
	(Direction	& 0x10)	? GPIO05_DIRECTION	= 1 : GPIO05_DIRECTION	= 0;
	(Level		& 0x10)	? GPIO04_Level		= 1	: GPIO04_Level		= 0;
	(Direction	& 0x20)	? GPIO06_DIRECTION	= 1 : GPIO06_DIRECTION	= 0;
	(Level		& 0x20)	? GPIO05_Level		= 1	: GPIO05_Level		= 0;
	(Direction	& 0x40)	? GPIO07_DIRECTION	= 1 : GPIO07_DIRECTION	= 0;
	(Level		& 0x40)	? GPIO06_Level		= 1	: GPIO06_Level		= 0;
	(Direction	& 0x80)	? GPIO08_DIRECTION	= 1 : GPIO08_DIRECTION	= 0;
	(Level		& 0x80)	? GPIO07_Level		= 1	: GPIO07_Level		= 0;

	UpdateData(false);

	HANDLE	hMonitor = CreateThread(	NULL,					// SD
										0,						// initial stack size
										ThreadProc_Monitor,		// thread function
										this,					// thread argument
										0,						// creation option
										&ThreadId				// thread identifier
										);

	return TRUE;  // restituisce TRUE a meno che non venga impostato lo stato attivo su un controllo.
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CEAPI_ExeDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_EAPI_WINCE_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_EAPI_WINCE_DIALOG));
	}
}
#endif

bool CEAPI_ExeDlg::HexToDec(CString HexString, unsigned char * Buff)
{
	switch(HexString[0])
	{
		case '0':
			Buff[0] = 0;
			break;
		case '1':
			Buff[0] = 1;
			break;
		case '2':
			Buff[0] = 2;
			break;
		case '3':
			Buff[0] = 3;
			break;
		case '4':
			Buff[0] = 4;
			break;
		case '5':
			Buff[0] = 5;
			break;
		case '6':
			Buff[0] = 6;
			break;
		case '7':
			Buff[0] = 7;
			break;
		case '8':
			Buff[0] = 8;
			break;
		case '9':
			Buff[0] = 9;
			break;
		case 'A':
			Buff[0] = 10;
			break;
		case 'B':
			Buff[0] = 11;
			break;
		case 'C':
			Buff[0] = 12;
			break;
		case 'D':
			Buff[0] = 13;
			break;
		case 'E':
			Buff[0] = 14;
			break;
		case 'F':
			Buff[0] = 15;
			break;
			break;
		default:
			return false;
			break;
	}

	return true;
}


bool CEAPI_ExeDlg::HexByteString2UnsignedChar(CString HexByteString, unsigned char * UnsignedCharReturned)
{
	unsigned char UnsignedCharReturned_temp;
	unsigned long dwLen = 0;
	unsigned long dwRet = 0;
	CString SingleByte;

	HexByteString.MakeUpper();

	SingleByte = HexByteString.Mid(0, 1);

	if(!HexToDec(SingleByte, &UnsignedCharReturned_temp))
	{return false;}

	(*UnsignedCharReturned) = (UnsignedCharReturned_temp << 4);

	SingleByte = HexByteString.Mid(1, 1);

	if(!HexToDec(SingleByte, &UnsignedCharReturned_temp))
	{return false;}

	(*UnsignedCharReturned) += UnsignedCharReturned_temp;

	return true;
}



bool CEAPI_ExeDlg::HexWordStringToUnsignedShort(CString HexString, unsigned short * Buffer)
{
	CString delim = _T(" ");
	CString SingleByte;
	int start= 0, end = 0, count = 0;
	unsigned char Buff = 0, countBuffer = 0;

	int lenght = HexString.GetLength();

	*Buffer = 0;

	if (lenght > 4)
		return false;

	HexString.MakeUpper();

	while(count < lenght)
	{
		SingleByte = HexString.Mid(count, 1);

		if(!HexToDec(SingleByte, &Buff))
		{
			return false;
		}

		*Buffer += (((unsigned short)Buff) << ((lenght - 1 - count) * 4));

		count++;
	}

	return true;
}


bool CEAPI_ExeDlg::HexDWordStringToUnsignedLong(CString HexString, unsigned long * Buffer)
{
	CString delim = _T(" ");
	CString SingleByte;
	int start= 0, end = 0, count = 0;
	unsigned char Buff = 0, countBuffer = 0;

	int lenght = HexString.GetLength();

	*Buffer = 0;

	if (lenght > 8)
		return false;

	HexString.MakeUpper();

	while(count < lenght)
	{
		SingleByte = HexString.Mid(count, 1);

		if(!HexToDec(SingleByte, &Buff))
		{
			return false;
		}

		*Buffer += (((unsigned short)Buff) << ((lenght - 1 - count) * 4));

		count++;
	}

	return true;
}

bool CEAPI_ExeDlg::HexStringToUnsignedChar(CString HexString, unsigned char * Buffer, unsigned long * LenBufferFind)
{
	CString delim = _T(" ");
	CString SingleByte;
	int start= 0, end = 0, count = 0;
	unsigned char Buff = 0;
	unsigned long countBuffer = 0;

	int lenght = HexString.GetLength();

	//if(lenght < 2)
	//{
	//	return false;
	//}

	HexString.MakeUpper();

	while(count <= lenght)
	{
		if(count < lenght)
		{
			// ------- 1 Byte -------
			SingleByte = HexString.Mid(count, 1);

			if(!HexToDec(SingleByte, &Buff))
			{
				return false;
			}

			Buffer[countBuffer] = (Buff << 4);

			count++;
		}
		else
		{
			return false;
		}

		if(count < lenght)
		{
			// ------- 2 Byte -------
			SingleByte = HexString.Mid(count, 1);

			if(!HexToDec(SingleByte, &Buff))
			{
				return false;
			}

			Buffer[countBuffer] += Buff;
			countBuffer++;
			(*LenBufferFind) = countBuffer;
			if(countBuffer > LEN_MAX_BYTE_BUFFER)
			{
				return false;
			}

			count++;
		}
		else
		{
			return false;
		}

		if(count < lenght)
		{
			// ------- Spazio -------
			SingleByte = HexString.Mid(count, 1);

			if(SingleByte[0] != ' ')
			{
				return false;
			}

			count++;
		}
		else
		{
			count++;
		}
	}

	return true;
}





void CEAPI_ExeDlg::OnBnClickedEnableWdt()
{
	UpdateData(true);

	switch(EApiWDogStart(m_Delay, m_Event, m_Reset))
	{
		case EAPI_STATUS_SUCCESS:
			GetDlgItem(IDC_ENABLE_WDT)->EnableWindow(FALSE);
			GetDlgItem(IDC_ENABLE_WDT_CUSTOM)->EnableWindow(FALSE);
			GetDlgItem(IDC_DISABLE_WDT)->EnableWindow(TRUE);
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(_T("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(_T("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_RUNNING:
			MessageBox(_T("EAPI_STATUS_RUNNING"), 0, 0);
			break;
		case EAPI_STATUS_INVALID_PARAMETER:
			MessageBox(_T("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(_T("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	return;
}

void CEAPI_ExeDlg::OnBnClickedDisableWdt()
{
	switch(EApiWDogStop())
	{
		case EAPI_STATUS_SUCCESS:
			GetDlgItem(IDC_ENABLE_WDT)->EnableWindow(TRUE);
			GetDlgItem(IDC_ENABLE_WDT_CUSTOM)->EnableWindow(TRUE);
			GetDlgItem(IDC_DISABLE_WDT)->EnableWindow(FALSE);
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(_T("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(_T("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(_T("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}
}

DWORD WINAPI CEAPI_ExeDlg::ThreadProc_Trigger(LPVOID lpParameter)
{
	uint32_t dwRet = 0;

	bTriggerFlag = true;

	CEAPI_ExeDlg* pWnd = (CEAPI_ExeDlg*) lpParameter;

	while(bTriggerFlag)
	{
		if(EApiWDogTrigger() != EAPI_STATUS_SUCCESS)
			if(EApiWDogTrigger() != EAPI_STATUS_SUCCESS)
				if(EApiWDogTrigger() != EAPI_STATUS_SUCCESS)
				{
					pWnd->MessageBox(_T("EApiWDogTrigger FAILED"), 0, 0);
				}

		if(pWnd->m_Timeout_Expressed)
		{
			Sleep(500);
		}
		else
		{
			Sleep(500);
		}
	}

	return 0;
}

void CEAPI_ExeDlg::OnBnClickedStartTrig()
{
	DWORD   ThreadId;

	GetDlgItem(IDC_START_TRIG)->EnableWindow(FALSE);
	GetDlgItem(IDC_STOP_TRIG)->EnableWindow(TRUE);

	UpdateData(true);
	
	if(m_Trigger_SW_HW == 0)
	{
		hTrigger = CreateThread(	NULL,					// SD
									0,						// initial stack size
									ThreadProc_Trigger,		// thread function
									this,					// thread argument
									0,						// creation option
									&ThreadId				// thread identifier
 									);
	}

	return;
}


void CEAPI_ExeDlg::OnBnClickedStopTrig()
{
	TerminateThread(ThreadProc_Trigger, 0);
	bTriggerFlag = false;
	GetDlgItem(IDC_START_TRIG)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP_TRIG)->EnableWindow(FALSE);
}

void CEAPI_ExeDlg::OnBnClickedI2cRead()
{
	wchar_t msg[1024];
	unsigned char Dev_Add_Byte;
	unsigned char bAddr = 0;
	unsigned char bRead = 0;
	unsigned long LenBufferFind = 0;
	unsigned long dwLen = 0;
	unsigned long dwRet = 0;
	CString SingleByte;
	uint32_t I2C_Mode;

	UpdateData(true);

	if(!HexByteString2UnsignedChar(m_DevAdd_String, &Dev_Add_Byte))
	{
		MessageBox(_T("Device Address Error"), 0, 0);
		return;
	}

	switch(m_I2C_Mode)
	{
		case 0:
			I2C_Mode = EAPI_ID_I2C_EXTERNAL;
			break;
		case 1:
			I2C_Mode = EAPI_ID_I2C_SPI;
			break;
		case 2:
			I2C_Mode = EAPI_ID_I2C_LVDS_1;
			break;
		case 3:
			I2C_Mode = EAPI_ID_I2C_INTERNAL;
			break;
	}	

	dwRet = EApiI2CWriteReadRaw(	I2C_Mode, 
									Dev_Add_Byte, 
									NULL,
									0,
									&bRead,
									sizeof(unsigned char),
									1);
	switch(dwRet)
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_ERROR:
			MessageBox(_T("EAPI_STATUS_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_INVALID_PARAMETER:
			MessageBox(_T("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			break;
		case EAPI_STATUS_NOT_FOUND:
			MessageBox(_T("EAPI_STATUS_NOT_FOUND"), 0, 0);
			break;
		case EAPI_STATUS_READ_ERROR:
			MessageBox(_T("EAPI_STATUS_READ_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_WRITE_ERROR:
			MessageBox(_T("EAPI_STATUS_WRITE_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_TIMEOUT:
			MessageBox(_T("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
		default:
			wsprintf(msg, _T("EAPI_ERROR N: 0x%08X"),dwRet);
			MessageBox(_T("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
	}
	
	m_Data_String.Format(_T("%02X"),bRead);

	UpdateData(false);
}


void CEAPI_ExeDlg::OnBnClickedI2cWrite()
{
	wchar_t msg[1024];
	unsigned char Dev_Add_Byte;
	uint32_t	  bAddr = 0;
	unsigned long LenBufferFind = 0;
	unsigned long dwLen = 0;
	unsigned long dwRet = 0;
	CString SingleByte;
	uint32_t I2C_Mode;

	unsigned char DataBuffer[LEN_MAX_BYTE_BUFFER];

	UpdateData(true);

	switch(m_I2C_Mode)
	{
		case 0:
			I2C_Mode = EAPI_ID_I2C_EXTERNAL;
			break;
		case 1:
			I2C_Mode = EAPI_ID_I2C_SPI;
			break;
		case 2:
			I2C_Mode = EAPI_ID_I2C_LVDS_1;
			break;
		case 3:
			I2C_Mode = EAPI_ID_I2C_INTERNAL;
			break;
	}

	if(!HexByteString2UnsignedChar(m_DevAdd_String, &Dev_Add_Byte))
	{
		MessageBox(_T("Device Address Field Error"), 0, 0);
		return;
	}

	if(!HexStringToUnsignedChar(m_Data_String, DataBuffer, &LenBufferFind))
	{
		MessageBox(_T("Data Field Error"), 0, 0);
		return;
	}

	dwRet = EApiI2CWriteReadRaw(	I2C_Mode, 
									Dev_Add_Byte, 
									DataBuffer,
									LenBufferFind,
									NULL,
									0,
									0);
	switch(dwRet)
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_ERROR:
			MessageBox(_T("EAPI_STATUS_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_INVALID_PARAMETER:
			MessageBox(_T("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			break;
		case EAPI_STATUS_NOT_FOUND:
			MessageBox(_T("EAPI_STATUS_NOT_FOUND"), 0, 0);
			break;
		case EAPI_STATUS_READ_ERROR:
			MessageBox(_T("EAPI_STATUS_READ_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_WRITE_ERROR:
			MessageBox(_T("EAPI_STATUS_WRITE_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_TIMEOUT:
			MessageBox(_T("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
		default:
			wsprintf(msg, _T("EAPI_ERROR N: 0x%08X"),dwRet);
			MessageBox(msg, 0, 0);
			break;
	}
	
	UpdateData(false);
}


void CEAPI_ExeDlg::OnBnClickedI2cReadReg()
{
	wchar_t msg[1024];
	unsigned char bRead = 0;
	unsigned char Dev_Add_Byte;
	unsigned char Reg_Byte;
	unsigned long dwLen = 0;
	unsigned long dwRet = 0;
	CString SingleByte;
	uint32_t I2C_Mode;

	UpdateData(true);

	switch(m_I2C_Mode)
	{
		case 0:
			I2C_Mode = EAPI_ID_I2C_EXTERNAL;
			break;
		case 1:
			I2C_Mode = EAPI_ID_I2C_SPI;
			break;
		case 2:
			I2C_Mode = EAPI_ID_I2C_LVDS_1;
			break;
		case 3:
			I2C_Mode = EAPI_ID_I2C_INTERNAL;
			break;
	}

	if(!HexByteString2UnsignedChar(m_DevAdd_String, &Dev_Add_Byte))
	{
		MessageBox(_T("Device Address Field Error"), 0, 0);
		return;
	}

	if(!HexByteString2UnsignedChar(m_Reg_String, &Reg_Byte))
	{
		MessageBox(_T("Reg Address Field Error"), 0, 0);
		return;
	}

	dwRet =  EApiI2CReadTransfer(	I2C_Mode, 
									Dev_Add_Byte, 
									Reg_Byte,
									&bRead,
									sizeof(bRead),
									1);
	switch(dwRet)
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_ERROR:
			MessageBox(_T("EAPI_STATUS_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_INVALID_PARAMETER:
			MessageBox(_T("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			break;
		case EAPI_STATUS_NOT_FOUND:
			MessageBox(_T("EAPI_STATUS_NOT_FOUND"), 0, 0);
			break;
		case EAPI_STATUS_READ_ERROR:
			MessageBox(_T("EAPI_STATUS_READ_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_WRITE_ERROR:
			MessageBox(_T("EAPI_STATUS_WRITE_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_TIMEOUT:
			MessageBox(_T("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
		default:
			wsprintf(msg, _T("EAPI_ERROR N: 0x%08X"),dwRet);
			MessageBox(_T("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
	}
	
	m_Data_String.Format(_T("%02X"),bRead);

	UpdateData(false);
}

void CEAPI_ExeDlg::OnBnClickedI2cWriteReg()
{
	wchar_t msg[1024];
	unsigned char Dev_Add_Byte;
	unsigned char Reg_Byte;
	unsigned char Data_Byte;
	unsigned long dwLen = 1;
	unsigned long dwRet = 0;
	CString SingleByte;
	uint32_t I2C_Mode;

	UpdateData(true);

	switch(m_I2C_Mode)
	{
		case 0:
			I2C_Mode = EAPI_ID_I2C_EXTERNAL;
			break;
		case 1:
			I2C_Mode = EAPI_ID_I2C_SPI;
			break;
		case 2:
			I2C_Mode = EAPI_ID_I2C_LVDS_1;
			break;
		case 3:
			I2C_Mode = EAPI_ID_I2C_INTERNAL;
			break;
	}

	if(!HexByteString2UnsignedChar(m_Data_String, &Data_Byte))
	{
		MessageBox(_T("Data Field Error"), 0, 0);
		return;
	}

	if(!HexByteString2UnsignedChar(m_DevAdd_String, &Dev_Add_Byte))
	{
		MessageBox(_T("Device Address Field Error"), 0, 0);
		return;
	}

	if(!HexByteString2UnsignedChar(m_Reg_String, &Reg_Byte))
	{
		MessageBox(_T("Reg Address Field Error"), 0, 0);
		return;
	}

	dwRet = EApiI2CWriteTransfer(	I2C_Mode, 
									Dev_Add_Byte, 
									Reg_Byte,
									&Data_Byte,
									1);
	
	switch(dwRet)
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_ERROR:
			MessageBox(_T("EAPI_STATUS_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_INVALID_PARAMETER:
			MessageBox(_T("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			break;
		case EAPI_STATUS_NOT_FOUND:
			MessageBox(_T("EAPI_STATUS_NOT_FOUND"), 0, 0);
			break;
		case EAPI_STATUS_READ_ERROR:
			MessageBox(_T("EAPI_STATUS_READ_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_WRITE_ERROR:
			MessageBox(_T("EAPI_STATUS_WRITE_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_TIMEOUT:
			MessageBox(_T("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
		default:
			wsprintf(msg, _T("EAPI_ERROR N: 0x%08X"),dwRet);
			MessageBox(_T("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
	}
	
	UpdateData(false);
}


DWORD WINAPI CEAPI_ExeDlg::ThreadProc_Monitor(LPVOID lpParameter)
{
	EApiStatus_t	Ret;
	unsigned long	dwID = 0;
	uint32_t		Temperature = 0;
	uint32_t		Mon_VCore	= 0;
	uint32_t		Mon_2V5		= 0;
	uint32_t		Mon_3V3		= 0;
	uint32_t		Mon_VBat	= 0;
	uint32_t		Mon_5V		= 0;
	uint32_t		Mon_5VSB	= 0;
	uint32_t		Mon_12V		= 0;
	uint32_t		RPM = 0;
	wchar_t 		msg[1024];

	CEAPI_ExeDlg* pWnd = (CEAPI_ExeDlg*) lpParameter;

	while(1)
	{
		if(EApiBoardGetValue(EAPI_ID_HWMON_CPU_TEMP, &Temperature) == EAPI_STATUS_SUCCESS)
		{
			wsprintf(msg,_T("%d (0.1K) %d (C)"), Temperature, (Temperature - 2731)/10);
			pWnd->m_Temperature1.SetWindowText(msg);
		}
		else
		{
			pWnd->m_Temperature1.SetWindowText(_T("Error"));
		}

		if(EApiBoardGetValue(EAPI_ID_HWMON_CHIPSET_TEMP, &Temperature) == EAPI_STATUS_SUCCESS)
		{
			wsprintf(msg,_T("%d (0.1K) %d (C)"), Temperature, (Temperature - 2731)/10);
			pWnd->m_Temperature2.SetWindowText(msg);
		}
		else
		{
			pWnd->m_Temperature2.SetWindowText(_T("Error"));
		}

				
		// ---------------------------------- Voltage ---------------------------------------

		Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_VCORE, &Mon_VCore);
		if(Ret == EAPI_STATUS_SUCCESS)
		{
			wsprintf(msg, _T("%5.3fV"), ((float)Mon_VCore)/1000);
			pWnd->m_VCore_Voltage.SetWindowText(msg);
		}
		else if (Ret == EAPI_STATUS_UNSUPPORTED)
		{
			pWnd->m_VCore_Voltage.SetWindowText(TEXT("Not Supported"));
		}
		else
		{
			pWnd->m_VCore_Voltage.SetWindowText(TEXT("Error"));
		}
		
		Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_2V5, &Mon_2V5);
		if(Ret == EAPI_STATUS_SUCCESS)
		{
			wsprintf(msg, _T("%5.3fV"), ((float)Mon_2V5)/1000);
			pWnd->m_2V5_Voltage.SetWindowText(msg);
		}
		else if (Ret == EAPI_STATUS_UNSUPPORTED)
		{
			pWnd->m_2V5_Voltage.SetWindowText(TEXT("Not Supported"));
		}
		else
		{
			pWnd->m_2V5_Voltage.SetWindowText(TEXT("Error"));
		}	

		Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_3V3, &Mon_3V3);
		if(Ret == EAPI_STATUS_SUCCESS)
		{
			wsprintf(msg, _T("%5.3fV"), ((float)Mon_3V3)/1000);
			pWnd->m_3V3_Voltage.SetWindowText(msg);
		}
		else if (Ret == EAPI_STATUS_UNSUPPORTED)
		{
			pWnd->m_3V3_Voltage.SetWindowText(TEXT("Not Supported"));
		}
		else
		{
			pWnd->m_3V3_Voltage.SetWindowText(TEXT("Error"));
		}	

		Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_VBAT, &Mon_VBat);
		if(Ret == EAPI_STATUS_SUCCESS)
		{
			wsprintf(msg, _T("%5.3fV"), ((float)Mon_VBat)/1000);
			pWnd->m_VBat_Voltage.SetWindowText(msg);
		}
		else if (Ret == EAPI_STATUS_UNSUPPORTED)
		{
			pWnd->m_VBat_Voltage.SetWindowText(TEXT("Not Supported"));
		}
		else
		{
			pWnd->m_VBat_Voltage.SetWindowText(TEXT("Error"));
		}

		Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_5V, &Mon_5V);
		if(Ret == EAPI_STATUS_SUCCESS)
		{
			wsprintf(msg, _T("%5.3fV"), ((float)Mon_5V)/1000);
			pWnd->m_5V_Voltage.SetWindowText(msg);
		}
		else if (Ret == EAPI_STATUS_UNSUPPORTED)
		{
			pWnd->m_5V_Voltage.SetWindowText(TEXT("Not Supported"));
		}
		else
		{
			pWnd->m_5V_Voltage.SetWindowText(TEXT("Error"));
		}

		Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_5VSB, &Mon_5VSB);
		if(Ret == EAPI_STATUS_SUCCESS)
		{
			wsprintf(msg, _T("%5.3fV"), ((float)Mon_5VSB)/1000);
			pWnd->m_5VSB_Voltage.SetWindowText(msg);
		}
		else if (Ret == EAPI_STATUS_UNSUPPORTED)
		{
			pWnd->m_5VSB_Voltage.SetWindowText(TEXT("Not Supported"));
		}
		else
		{
			pWnd->m_5VSB_Voltage.SetWindowText(TEXT("Error"));
		}

		Ret = EApiBoardGetValue(EAPI_ID_HWMON_VOLTAGE_12V, &Mon_12V);
		if(Ret == EAPI_STATUS_SUCCESS)
		{
			wsprintf(msg, _T("%5.3fV"), ((float)Mon_12V)/1000);
			pWnd->m_12V_Voltage.SetWindowText(msg);
		}
		else if (Ret == EAPI_STATUS_UNSUPPORTED)
		{
			pWnd->m_12V_Voltage.SetWindowText(TEXT("Not Supported"));
		}
		else
		{
			pWnd->m_12V_Voltage.SetWindowText(TEXT("Error"));
		}

		// ---------------------------------- Fan RPM ---------------------------------------
		if(EApiBoardGetValue(EAPI_ID_HWMON_FAN_CPU, &RPM) == EAPI_STATUS_SUCCESS)
		{
			wsprintf(msg,_T("%d"), RPM);
			pWnd->m_Fan_RPM.SetWindowText(msg);
		}
		else
		{
			pWnd->m_Fan_RPM.SetWindowText(TEXT("Not Supported"));
		}


		// ---------------------------------- Fan RPM ---------------------------------------
		if(EApiBoardGetValue(EAPI_ID_HWMON_FAN_SYSTEM, &RPM) == EAPI_STATUS_SUCCESS)
		{
			wsprintf(msg,_T("%d"), RPM);
			pWnd->m_Fan_RPM2.SetWindowText(msg);
		}
		else
		{
			pWnd->m_Fan_RPM2.SetWindowText(TEXT("Not Supported"));
		}

		Sleep(1000);
	};

	return 0;
}
void CEAPI_ExeDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);

	unsigned long value;
	wchar_t msg[1024];

	if(1)
	{
		value = m_slider_backlight.GetPos();

		EApiVgaSetBacklightBrightness(EAPI_ID_BACKLIGHT_1, value);

		m_slider_backlight.SetPos(value);
		wsprintf(msg,_T("%d %%"), value);
		m_label_backlight.SetWindowText(msg);
	}
}







void CEAPI_ExeDlg::OnBnClickedGPIO01()
{
	uint32_t Bitmask = MASK_BIT0;
	EApiStatus_t a;
	uint32_t Level;

	UpdateData(true);

	(GPIO00_Level) ? Level = 0x000000FF : Level = 0x00000000;
	
	a = EApiGPIOSetLevel(EAPI_ID_GPIO_BANK00, Bitmask, Level);

	return;
}

void CEAPI_ExeDlg::OnBnClickedGPIO02()
{
	uint32_t Bitmask = MASK_BIT1;
	EApiStatus_t a;
	uint32_t Level;

	UpdateData(true);

	(GPIO01_Level) ? Level = 0x000000FF : Level = 0x00000000;

	a = EApiGPIOSetLevel(EAPI_ID_GPIO_BANK00, Bitmask, Level);

	return;
}

void CEAPI_ExeDlg::OnBnClickedGPIO03()
{
	uint32_t Bitmask = MASK_BIT2;
	EApiStatus_t a;
	uint32_t Level;

	UpdateData(true);

	(GPIO02_Level) ? Level = 0x000000FF : Level = 0x00000000;
	
	a = EApiGPIOSetLevel(EAPI_ID_GPIO_BANK00, Bitmask, Level);

	return;
}

void CEAPI_ExeDlg::OnBnClickedGPIO04()
{
	uint32_t Bitmask = MASK_BIT3;
	EApiStatus_t a;
	uint32_t Level;

	UpdateData(true);

	(GPIO03_Level) ? Level = 0x000000FF : Level = 0x00000000;
	
	a = EApiGPIOSetLevel(EAPI_ID_GPIO_BANK00, Bitmask, Level);

	return;
}

void CEAPI_ExeDlg::OnBnClickedGPIO17()
{
	uint32_t Bitmask = MASK_BIT4;
	EApiStatus_t a;
	uint32_t Level;

	UpdateData(true);

	(GPIO04_Level) ? Level = 0x000000FF : Level = 0x00000000;
	
	a = EApiGPIOSetLevel(EAPI_ID_GPIO_BANK00, Bitmask, Level);

	return;
}

void CEAPI_ExeDlg::OnBnClickedGPIO20()
{
	uint32_t Bitmask = MASK_BIT5;
	EApiStatus_t a;
	uint32_t Level;

	UpdateData(true);

	(GPIO05_Level) ? Level = 0x000000FF : Level = 0x00000000;
	
	a = EApiGPIOSetLevel(EAPI_ID_GPIO_BANK00, Bitmask, Level);

	return;
}

void CEAPI_ExeDlg::OnBnClickedGPIO21()
{
	uint32_t Bitmask = MASK_BIT6;
	EApiStatus_t a;
	uint32_t Level;

	UpdateData(true);

	(GPIO06_Level) ? Level = 0x000000FF : Level = 0x00000000;

	a = EApiGPIOSetLevel(EAPI_ID_GPIO_BANK00, Bitmask, Level);

	return;
}

void CEAPI_ExeDlg::OnBnClickedGPIO22()
{
	uint32_t Bitmask = MASK_BIT7;
	EApiStatus_t a;
	uint32_t Level;

	UpdateData(true);

	(GPIO07_Level) ? Level = 0x000000FF : Level = 0x00000000;

	a = EApiGPIOSetLevel(EAPI_ID_GPIO_BANK00, Bitmask, Level);

	return;
}










void CEAPI_ExeDlg::OnBnClickedCheck11()
{
	uint32_t Bitmask = 0x00000001;
	uint32_t Direction;
	EApiStatus_t a;

	UpdateData(true);

	if(GPIO01_DIRECTION)
	{
		Direction = 0x000000FF;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO01)->EnableWindow(FALSE);
	}
	else
	{
		Direction = 0x00000000;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);	

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO01)->EnableWindow(TRUE);
	}

	if(a != EAPI_STATUS_SUCCESS)
	{
		GPIO01_DIRECTION = !GPIO01_DIRECTION; 
		MessageBox(TEXT("EApiGPIOSetDirection Error"), 0, 0);
	}

	UpdateData(false);

	return;
}

void CEAPI_ExeDlg::OnBnClickedCheck12()
{
	uint32_t Bitmask = 0x00000002;
	uint32_t Direction;
	EApiStatus_t a;

	UpdateData(true);
	if(GPIO02_DIRECTION)
	{
		Direction = 0x000000FF;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO02)->EnableWindow(FALSE);
	}
	else
	{
		Direction = 0x00000000;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);		

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO02)->EnableWindow(TRUE);
	}

	if(a != EAPI_STATUS_SUCCESS)
	{
		GPIO02_DIRECTION = !GPIO02_DIRECTION; 
		MessageBox(TEXT("EApiGPIOSetDirection Error"), 0, 0);
	}

	UpdateData(false);

	return;
}

void CEAPI_ExeDlg::OnBnClickedCheck13()
{
	uint32_t Bitmask = 0x00000004;
	uint32_t Direction;
	EApiStatus_t a;

	UpdateData(true);
	if(GPIO03_DIRECTION)
	{
		Direction = 0x000000FF;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);
		
		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO03)->EnableWindow(FALSE);
	}
	else
	{
		Direction = 0x00000000;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO03)->EnableWindow(TRUE);
	}

	if(a != EAPI_STATUS_SUCCESS)
	{
		GPIO03_DIRECTION = !GPIO03_DIRECTION; 
		MessageBox(TEXT("EApiGPIOSetDirection Error"), 0, 0);
	}

	UpdateData(false);

	return;
}

void CEAPI_ExeDlg::OnBnClickedCheck14()
{
	uint32_t Bitmask = 0x00000008;
	uint32_t Direction;
	EApiStatus_t a;

	UpdateData(true);
	if(GPIO04_DIRECTION)
	{
		Direction = 0x000000FF;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO04)->EnableWindow(FALSE);
	}
	else
	{
		Direction = 0x00000000;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO04)->EnableWindow(TRUE);
	}

	if(a != EAPI_STATUS_SUCCESS)
	{
		GPIO04_DIRECTION = !GPIO04_DIRECTION; 
		MessageBox(TEXT("EApiGPIOSetDirection Error"), 0, 0);
	}

	UpdateData(false);

	return;
}

void CEAPI_ExeDlg::OnBnClickedCheck15()
{
	uint32_t Bitmask = 0x00000010;
	uint32_t Direction;
	EApiStatus_t a;

	UpdateData(true);
	if(GPIO05_DIRECTION)
	{
		Direction = 0x000000FF;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO05)->EnableWindow(FALSE);
	}
	else
	{
		Direction = 0x00000000;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO05)->EnableWindow(TRUE);
	}

	if(a != EAPI_STATUS_SUCCESS)
	{
		GPIO05_DIRECTION = !GPIO05_DIRECTION; 
		MessageBox(TEXT("EApiGPIOSetDirection Error"), 0, 0);
	}

	UpdateData(false);

	return;
}

void CEAPI_ExeDlg::OnBnClickedCheck16()
{
	uint32_t Bitmask = 0x00000020;
	uint32_t Direction;
	EApiStatus_t a;

	UpdateData(true);
	if(GPIO06_DIRECTION)
	{
		Direction = 0x000000FF;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO06)->EnableWindow(FALSE);
	}
	else
	{
		Direction = 0x00000000;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO06)->EnableWindow(TRUE);
	}

	if(a != EAPI_STATUS_SUCCESS)
	{
		GPIO06_DIRECTION = !GPIO06_DIRECTION; 
		MessageBox(TEXT("EApiGPIOSetDirection Error"), 0, 0);
	}

	UpdateData(false);

	return;
}

void CEAPI_ExeDlg::OnBnClickedCheck17()
{
	uint32_t Bitmask = 0x00000040;
	uint32_t Direction;
	EApiStatus_t a;

	UpdateData(true);
	if(GPIO07_DIRECTION)
	{
		Direction = 0x000000FF;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO07)->EnableWindow(FALSE);
	}
	else
	{
		Direction = 0x00000000;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO07)->EnableWindow(TRUE);
	}

	if(a != EAPI_STATUS_SUCCESS)
	{
		GPIO07_DIRECTION = !GPIO07_DIRECTION; 
		MessageBox(TEXT("EApiGPIOSetDirection Error"), 0, 0);
	}

	UpdateData(false);

	return;
}

void CEAPI_ExeDlg::OnBnClickedCheck18()
{
	uint32_t Bitmask = 0x00000080;
	uint32_t Direction;
	EApiStatus_t a;

	UpdateData(true);
	if(GPIO08_DIRECTION)
	{
		Direction = 0x000000FF;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO08)->EnableWindow(FALSE);
	}
	else
	{
		Direction = 0x00000000;
		a = EApiGPIOSetDirection(EAPI_ID_GPIO_BANK00, Bitmask, Direction);

		if(a == EAPI_STATUS_SUCCESS)GetDlgItem(IDC_LEVEL_GPIO08)->EnableWindow(TRUE);
	}

	if(a != EAPI_STATUS_SUCCESS)
	{
		GPIO08_DIRECTION = !GPIO08_DIRECTION; 
		MessageBox(TEXT("EApiGPIOSetDirection Error"), 0, 0);
	}

	UpdateData(false);

	return;
}








void CEAPI_ExeDlg::OnBnClickedRadio10()
{
	EApiGPIOSetSerialCfg(GPIO_SERIAL_MODE_RS232);	
}

void CEAPI_ExeDlg::OnBnClickedRadio15()
{
	EApiGPIOSetSerialCfg(GPIO_SERIAL_MODE_RS422);	
}

void CEAPI_ExeDlg::OnBnClickedRadio16()
{
	EApiGPIOSetSerialCfg(GPIO_SERIAL_MODE_RS485TX);	
}

void CEAPI_ExeDlg::OnBnClickedRadio17()
{
	EApiGPIOSetSerialCfg(GPIO_SERIAL_MODE_RS485RX);	
}




// -------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------

void CEAPI_ExeDlg::OnBnClickedEnableFAN()
{
	unsigned long dwRet = 0;

	UpdateData(true);

	switch(EApiFanEnable(m_Fan_Cycle, m_Fan_Duty))
	{
		case EAPI_STATUS_SUCCESS:
			GetDlgItem(IDC_ENABLE_FAN)->EnableWindow(FALSE);
			GetDlgItem(IDC_DISABLE_FAN)->EnableWindow(TRUE);
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(TEXT("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	return;
}

void CEAPI_ExeDlg::OnBnClickedDisableFAN()
{
	unsigned long dwRet = 0;

	switch(EApiFanDisable())
	{
		case EAPI_STATUS_SUCCESS:
			GetDlgItem(IDC_ENABLE_FAN)->EnableWindow(TRUE);
			GetDlgItem(IDC_DISABLE_FAN)->EnableWindow(FALSE);
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(TEXT("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	return;
}


// ------------------------------------------------------------------------------------------------------------------

void CEAPI_ExeDlg::OnBnClickedGetCycle()
{
	unsigned long dwRet = 0;

	switch(EApiFanPWMGetCycle(&m_Fan_Cycle))
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(TEXT("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	UpdateData(false);

	return;
}

void CEAPI_ExeDlg::OnBnClickedSetCycle()
{

	UpdateData(true);

	switch(EApiFanPWMSetCycle(m_Fan_Cycle))
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(TEXT("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	return;
}

void CEAPI_ExeDlg::OnBnClickedGetDutyCycle()
{
	switch(EApiFanPWMGetDutyCycle(&m_Fan_Duty))
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(TEXT("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	UpdateData(false);

	return;
}

void CEAPI_ExeDlg::OnBnClickedSetDutyCycle()
{
	UpdateData(true);
	
	switch(EApiFanPWMSetDutyCycle(m_Fan_Cycle, m_Fan_Duty))
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(TEXT("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	return;
}

void CEAPI_ExeDlg::OnBnClicked_NVS_Write()
{
	unsigned long dwID = 0;
	unsigned long Dev_Add_Byte;
	unsigned char bAddr = 0;
	unsigned long LenBufferFind = 0;
	unsigned long dwLen = 0;
	EApiStatus_t Size = 0;
	CString SingleByte;
	uint32_t  BlockLength;

	unsigned char DataBuffer[LEN_MAX_BYTE_BUFFER];
	
	memset(DataBuffer, 0, 256);

	UpdateData(true);

	if(!HexDWordStringToUnsignedLong(m_NVS_Address, &Dev_Add_Byte))
	{
		MessageBox(_T("Device Address Field Error"), 0, 0);
		return;
	}

	if(!HexStringToUnsignedChar(m_NVS_Data, DataBuffer, &LenBufferFind))
	{
		MessageBox(_T("Data Field Error"), 0, 0);
		return;
	}

	switch(EApiStorageCap(EAPI_ID_STORAGE_STD, &Size, &BlockLength))
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_ERROR:
			MessageBox(_T("EAPI_STATUS_ERROR"), 0, 0);
			return;
			break;
		case EAPI_STATUS_INVALID_PARAMETER:
			MessageBox(_T("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			return;
			break;
		case EAPI_STATUS_NOT_FOUND:
			MessageBox(_T("EAPI_STATUS_NOT_FOUND"), 0, 0);
			return;
			break;
		case EAPI_STATUS_READ_ERROR:
			MessageBox(_T("EAPI_STATUS_READ_ERROR"), 0, 0);
			return;
			break;
		case EAPI_STATUS_WRITE_ERROR:
			MessageBox(_T("EAPI_STATUS_WRITE_ERROR"), 0, 0);
			return;
			break;
		case EAPI_STATUS_TIMEOUT:
			MessageBox(_T("EAPI_STATUS_TIMEOUT"), 0, 0);
			return;
			break;
		default:
			return;
			break;
	}

	if(Dev_Add_Byte + LenBufferFind > Size)
	{
		MessageBox(_T("Too much byte to write"), 0, 0);
		return;
	}

	switch(EApiStorageAreaWrite(EAPI_ID_STORAGE_STD, Dev_Add_Byte, DataBuffer, LenBufferFind))
	{
		case EAPI_STATUS_ERROR:
			MessageBox(_T("EAPI_STATUS_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_INVALID_PARAMETER:
			MessageBox(_T("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			break;
		case EAPI_STATUS_NOT_FOUND:
			MessageBox(_T("EAPI_STATUS_NOT_FOUND"), 0, 0);
			break;
		case EAPI_STATUS_READ_ERROR:
			MessageBox(_T("EAPI_STATUS_READ_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_WRITE_ERROR:
			MessageBox(_T("EAPI_STATUS_WRITE_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_TIMEOUT:
			MessageBox(_T("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
		default:
			break;
	}
}

void CEAPI_ExeDlg::OnBnClicked_NVS_Read()
{
	unsigned long dwID = 0;
	unsigned long Dev_Add_Byte;
	unsigned char bAddr = 0;
	unsigned long LenBufferFind = 0;
	unsigned char bRead[1024];
	unsigned long dwRet = 0;
	EApiStatus_t Size = 0;
	CString MultipleByte;
	uint32_t  BlockLength;

	UpdateData(true);

	if(!HexDWordStringToUnsignedLong(m_NVS_Address, &Dev_Add_Byte))
	{
		MessageBox(_T("Device Address Error"), 0, 0);
		return;
	}

	switch(EApiStorageCap(EAPI_ID_STORAGE_STD, &Size, &BlockLength))
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_ERROR:
			MessageBox(_T("EAPI_STATUS_ERROR"), 0, 0);
			return;
			break;
		case EAPI_STATUS_INVALID_PARAMETER:
			MessageBox(_T("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			return;
			break;
		case EAPI_STATUS_NOT_FOUND:
			MessageBox(_T("EAPI_STATUS_NOT_FOUND"), 0, 0);
			return;
			break;
		case EAPI_STATUS_READ_ERROR:
			MessageBox(_T("EAPI_STATUS_READ_ERROR"), 0, 0);
			return;
			break;
		case EAPI_STATUS_WRITE_ERROR:
			MessageBox(_T("EAPI_STATUS_WRITE_ERROR"), 0, 0);
			return;
			break;
		case EAPI_STATUS_TIMEOUT:
			MessageBox(_T("EAPI_STATUS_TIMEOUT"), 0, 0);
			return;
			break;
		default:
			return;
			break;
	}

	if((uint32_t)(Dev_Add_Byte + m_Storage_num_byte_to_read) > Size)
	{
		MessageBox(_T("Too much byte to read"), 0, 0);
		return;
	}

	switch(EApiStorageAreaRead(EAPI_ID_STORAGE_STD, Dev_Add_Byte, bRead, 1024,m_Storage_num_byte_to_read))
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_ERROR:
			MessageBox(_T("EAPI_STATUS_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_INVALID_PARAMETER:
			MessageBox(_T("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			break;
		case EAPI_STATUS_NOT_FOUND:
			MessageBox(_T("EAPI_STATUS_NOT_FOUND"), 0, 0);
			break;
		case EAPI_STATUS_READ_ERROR:
			MessageBox(_T("EAPI_STATUS_READ_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_WRITE_ERROR:
			MessageBox(_T("EAPI_STATUS_WRITE_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_TIMEOUT:
			MessageBox(_T("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
		default:
			break;
	}
	
	m_NVS_Data = _T("");
	for(int q = 0; q <  m_Storage_num_byte_to_read; q++)
	{
		MultipleByte.Format(_T("%02X "),bRead[q]);
		m_NVS_Data += MultipleByte;
	}

	UpdateData(false);
}


void CEAPI_ExeDlg::OnBnClickedBacklEna()
{
	EApiStatus_t	Ret;

	UpdateData(true);
	if(m_BKL_Enable)
	{
		Ret = EApiVgaSetBacklightEnable(EAPI_ID_BACKLIGHT_1, EAPI_BACKLIGHT_SET_ON);
	}
	else
	{
		Ret = EApiVgaSetBacklightEnable(EAPI_ID_BACKLIGHT_1, EAPI_BACKLIGHT_SET_OFF);
	}

	return;
}

void CEAPI_ExeDlg::OnBnClickedPitxNone()
{
	EApiStatus_t Ret;
	uint32_t		Bitmask		= 0x000000FF;
	uint32_t		Direction;
	uint32_t		Level;
	uint32_t		Inputs, Outputs;

	m_CarrierBoard = CARRIER_NONE;	

	EApiSetCarrier(m_CarrierBoard);

	UpdateData(true);

	// ---------------------------------- GPIO ---------------------------------------


	if(EApiGPIOGetDirectionCaps(EAPI_ID_GPIO_BANK00, &Inputs, &Outputs) == EAPI_STATUS_SUCCESS)
	{
		if(((Inputs & Outputs) & 0x01) != 0) GetDlgItem(IDC_DIRECTION_GPIO01)->EnableWindow(TRUE);
		if(((Inputs & Outputs) & 0x02) != 0) GetDlgItem(IDC_DIRECTION_GPIO02)->EnableWindow(TRUE);
		if(((Inputs & Outputs) & 0x04) != 0) GetDlgItem(IDC_DIRECTION_GPIO03)->EnableWindow(TRUE);
		if(((Inputs & Outputs) & 0x08) != 0) GetDlgItem(IDC_DIRECTION_GPIO04)->EnableWindow(TRUE);
		if(((Inputs & Outputs) & 0x10) != 0) GetDlgItem(IDC_DIRECTION_GPIO05)->EnableWindow(TRUE);
		if(((Inputs & Outputs) & 0x20) != 0) GetDlgItem(IDC_DIRECTION_GPIO06)->EnableWindow(TRUE);
		if(((Inputs & Outputs) & 0x40) != 0) GetDlgItem(IDC_DIRECTION_GPIO07)->EnableWindow(TRUE);
		if(((Inputs & Outputs) & 0x80) != 0) GetDlgItem(IDC_DIRECTION_GPIO08)->EnableWindow(TRUE);
	}
	else 
		return;

	Ret = EApiGPIOGetDirection(EAPI_ID_GPIO_BANK00, Bitmask, &Direction);
	if(Ret != EAPI_STATUS_SUCCESS) MessageBox(TEXT("EApiGPIO_SECO_GetDirection Error"), 0, 0);

	Ret = EApiGPIOGetLevel(EAPI_ID_GPIO_BANK00, Bitmask, &Level);
	if(Ret != EAPI_STATUS_SUCCESS) MessageBox(TEXT("EApiGPIO_SECO_GetLevel Error"), 0, 0);

	if(Direction & 0x01)GetDlgItem(IDC_LEVEL_GPIO01)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO01)->EnableWindow(TRUE);
	if(Direction & 0x02)GetDlgItem(IDC_LEVEL_GPIO02)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO02)->EnableWindow(TRUE);
	if(Direction & 0x04)GetDlgItem(IDC_LEVEL_GPIO03)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO03)->EnableWindow(TRUE);
	if(Direction & 0x08)GetDlgItem(IDC_LEVEL_GPIO04)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO04)->EnableWindow(TRUE);
	if(Direction & 0x10)GetDlgItem(IDC_LEVEL_GPIO05)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO05)->EnableWindow(TRUE);
	if(Direction & 0x20)GetDlgItem(IDC_LEVEL_GPIO06)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO06)->EnableWindow(TRUE);
	if(Direction & 0x40)GetDlgItem(IDC_LEVEL_GPIO07)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO07)->EnableWindow(TRUE);
	if(Direction & 0x80)GetDlgItem(IDC_LEVEL_GPIO08)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO08)->EnableWindow(TRUE);

	(Direction	& 0x01)	? GPIO01_DIRECTION	= 1 : GPIO01_DIRECTION	= 0;
	(Level		& 0x01)	? GPIO00_Level		= 1	: GPIO00_Level		= 0;
	(Direction	& 0x02)	? GPIO02_DIRECTION	= 1 : GPIO02_DIRECTION	= 0;
	(Level		& 0x02)	? GPIO01_Level		= 1	: GPIO01_Level		= 0;
	(Direction	& 0x04)	? GPIO03_DIRECTION	= 1 : GPIO03_DIRECTION	= 0;
	(Level		& 0x04)	? GPIO02_Level		= 1	: GPIO02_Level		= 0;
	(Direction	& 0x08)	? GPIO04_DIRECTION	= 1 : GPIO04_DIRECTION	= 0;
	(Level		& 0x08)	? GPIO03_Level		= 1	: GPIO03_Level		= 0;
	(Direction	& 0x10)	? GPIO05_DIRECTION	= 1 : GPIO05_DIRECTION	= 0;
	(Level		& 0x10)	? GPIO04_Level		= 1	: GPIO04_Level		= 0;
	(Direction	& 0x20)	? GPIO06_DIRECTION	= 1 : GPIO06_DIRECTION	= 0;
	(Level		& 0x20)	? GPIO05_Level		= 1	: GPIO05_Level		= 0;
	(Direction	& 0x40)	? GPIO07_DIRECTION	= 1 : GPIO07_DIRECTION	= 0;
	(Level		& 0x40)	? GPIO06_Level		= 1	: GPIO06_Level		= 0;
	(Direction	& 0x80)	? GPIO08_DIRECTION	= 1 : GPIO08_DIRECTION	= 0;
	(Level		& 0x80)	? GPIO07_Level		= 1	: GPIO07_Level		= 0;	
	
	UpdateData(false);

	GetDlgItem(IDC_PITX_799)->EnableWindow(FALSE);
	GetDlgItem(IDC_PITX_901)->EnableWindow(FALSE);
	GetDlgItem(IDC_0A42)->EnableWindow(FALSE);
	GetDlgItem(IDC_0A19)->EnableWindow(FALSE);
	GetDlgItem(IDC_RS232)->EnableWindow(FALSE);
	GetDlgItem(IDC_RS422)->EnableWindow(FALSE);
	GetDlgItem(IDC_RS485RX)->EnableWindow(FALSE);
	GetDlgItem(IDC_RS485TX)->EnableWindow(FALSE);
}


void CEAPI_ExeDlg::OnBnClickedPitx799()
{
	EApiStatus_t Ret;
	uint32_t		Bitmask		= 0x000000FF;
	uint32_t		Direction;
	uint32_t		Level;
	uint8_t			Val_GPIO_SERIAL_MODE;
	uint32_t		Inputs, Outputs;

	m_CarrierBoard = CARRIER_M799;	

	EApiSetCarrier(m_CarrierBoard);

	UpdateData(true);	
	
	if(EApiGPIOGetDirectionCaps(EAPI_ID_GPIO_BANK00, &Inputs, &Outputs) == EAPI_STATUS_SUCCESS)
	{
		GetDlgItem(IDC_LEVEL_GPIO01)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO02)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO03)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO04)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO05)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO06)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO07)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO08)->EnableWindow(TRUE);

		GetDlgItem(IDC_DIRECTION_GPIO01)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO02)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO03)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO04)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO05)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO06)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO07)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO08)->EnableWindow(TRUE);

		GetDlgItem(IDC_RS232)->EnableWindow(TRUE);
		GetDlgItem(IDC_RS422)->EnableWindow(TRUE);
		GetDlgItem(IDC_RS485RX)->EnableWindow(TRUE);
		GetDlgItem(IDC_RS485TX)->EnableWindow(TRUE);
	}
	else 
		return;

	// ---------------------------------- GPIO ---------------------------------------

	Ret = EApiGPIOGetDirection(EAPI_ID_GPIO_BANK00, Bitmask, &Direction);
	if(Ret != EAPI_STATUS_SUCCESS) MessageBox(TEXT("EApiGPIO_SECO_GetDirection Error"), 0, 0);
	Ret = EApiGPIOGetLevel(EAPI_ID_GPIO_BANK00, Bitmask, &Level);
	if(Ret != EAPI_STATUS_SUCCESS) MessageBox(TEXT("EApiGPIO_SECO_GetLevel Error"), 0, 0);

	(Direction	& 0x01)	? GPIO01_DIRECTION	= 1 : GPIO01_DIRECTION	= 0;
	(Level		& 0x01)	? GPIO00_Level		= 1	: GPIO00_Level		= 0;
	(Direction	& 0x02)	? GPIO02_DIRECTION	= 1 : GPIO02_DIRECTION	= 0;
	(Level		& 0x02)	? GPIO01_Level		= 1	: GPIO01_Level		= 0;
	(Direction	& 0x04)	? GPIO03_DIRECTION	= 1 : GPIO03_DIRECTION	= 0;
	(Level		& 0x04)	? GPIO02_Level		= 1	: GPIO02_Level		= 0;
	(Direction	& 0x08)	? GPIO04_DIRECTION	= 1 : GPIO04_DIRECTION	= 0;
	(Level		& 0x08)	? GPIO03_Level		= 1	: GPIO03_Level		= 0;
	(Direction	& 0x10)	? GPIO05_DIRECTION	= 1 : GPIO05_DIRECTION	= 0;
	(Level		& 0x10)	? GPIO04_Level		= 1	: GPIO04_Level		= 0;
	(Direction	& 0x20)	? GPIO06_DIRECTION	= 1 : GPIO06_DIRECTION	= 0;
	(Level		& 0x20)	? GPIO05_Level		= 1	: GPIO05_Level		= 0;
	(Direction	& 0x40)	? GPIO07_DIRECTION	= 1 : GPIO07_DIRECTION	= 0;
	(Level		& 0x40)	? GPIO06_Level		= 1	: GPIO06_Level		= 0;
	(Direction	& 0x80)	? GPIO08_DIRECTION	= 1 : GPIO08_DIRECTION	= 0;
	(Level		& 0x80)	? GPIO07_Level		= 1	: GPIO07_Level		= 0;
	
	Ret = EApiGPIOGetSerialCfg(&Val_GPIO_SERIAL_MODE);
	if(Ret != EAPI_STATUS_SUCCESS) MessageBox(TEXT("EApiGPIO_SECO_GetSerialCfg Error"), 0, 0);

	switch(Val_GPIO_SERIAL_MODE)
	{
		case GPIO_SERIAL_MODE_RS232:
			m_GPIO_Serial = 0;
			break;
		case GPIO_SERIAL_MODE_RS422:
			m_GPIO_Serial = 1;
			break;
		case GPIO_SERIAL_MODE_RS485TX:
			m_GPIO_Serial = 2;
			break;
		case GPIO_SERIAL_MODE_RS485RX:
			m_GPIO_Serial = 3;
			break;
		default:
			break;
	}

	UpdateData(false);

	GetDlgItem(IDC_PITX_NONE)->EnableWindow(FALSE);
	GetDlgItem(IDC_PITX_901)->EnableWindow(FALSE);
	GetDlgItem(IDC_0A42)->EnableWindow(FALSE);
	GetDlgItem(IDC_0A19)->EnableWindow(FALSE);
}

void CEAPI_ExeDlg::OnBnClickedPitx901()
{
	EApiStatus_t Ret;
	uint32_t		Bitmask		= 0x000000FF;
	uint32_t		Direction;
	uint32_t		Level;
	uint8_t			Val_GPIO_SERIAL_MODE;
	uint32_t		Inputs, Outputs;

	m_CarrierBoard = CARRIER_M901;

	EApiSetCarrier(m_CarrierBoard);

	UpdateData(true);

	if(EApiGPIOGetDirectionCaps(EAPI_ID_GPIO_BANK00, &Inputs, &Outputs) == EAPI_STATUS_SUCCESS)
	{
		GetDlgItem(IDC_LEVEL_GPIO01)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO02)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO03)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO04)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO05)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO06)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO07)->EnableWindow(TRUE);
		GetDlgItem(IDC_LEVEL_GPIO08)->EnableWindow(TRUE);

		GetDlgItem(IDC_DIRECTION_GPIO01)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO02)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO03)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO04)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO05)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO06)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO07)->EnableWindow(TRUE);
		GetDlgItem(IDC_DIRECTION_GPIO08)->EnableWindow(TRUE);

		GetDlgItem(IDC_RS232)->EnableWindow(TRUE);
		GetDlgItem(IDC_RS422)->EnableWindow(TRUE);
		GetDlgItem(IDC_RS485RX)->EnableWindow(TRUE);
		GetDlgItem(IDC_RS485TX)->EnableWindow(TRUE);
	}
	else 
		return;

	// ---------------------------------- GPIO ---------------------------------------

	Ret = EApiGPIOGetDirection(EAPI_ID_GPIO_BANK00, Bitmask, &Direction);
	if(Ret != EAPI_STATUS_SUCCESS) MessageBox(TEXT("EApiGPIO_SECO_GetDirection Error"), 0, 0);
	Ret = EApiGPIOGetLevel(EAPI_ID_GPIO_BANK00, Bitmask, &Level);
	if(Ret != EAPI_STATUS_SUCCESS) MessageBox(TEXT("EApiGPIO_SECO_GetLevel Error"), 0, 0);

	(Direction	& 0x01)	? GPIO01_DIRECTION	= 1 : GPIO01_DIRECTION	= 0;
	(Level		& 0x01)	? GPIO00_Level		= 1	: GPIO00_Level		= 0;
	(Direction	& 0x02)	? GPIO02_DIRECTION	= 1 : GPIO02_DIRECTION	= 0;
	(Level		& 0x02)	? GPIO01_Level		= 1	: GPIO01_Level		= 0;
	(Direction	& 0x04)	? GPIO03_DIRECTION	= 1 : GPIO03_DIRECTION	= 0;
	(Level		& 0x04)	? GPIO02_Level		= 1	: GPIO02_Level		= 0;
	(Direction	& 0x08)	? GPIO04_DIRECTION	= 1 : GPIO04_DIRECTION	= 0;
	(Level		& 0x08)	? GPIO03_Level		= 1	: GPIO03_Level		= 0;
	(Direction	& 0x10)	? GPIO05_DIRECTION	= 1 : GPIO05_DIRECTION	= 0;
	(Level		& 0x10)	? GPIO04_Level		= 1	: GPIO04_Level		= 0;
	(Direction	& 0x20)	? GPIO06_DIRECTION	= 1 : GPIO06_DIRECTION	= 0;
	(Level		& 0x20)	? GPIO05_Level		= 1	: GPIO05_Level		= 0;
	(Direction	& 0x40)	? GPIO07_DIRECTION	= 1 : GPIO07_DIRECTION	= 0;
	(Level		& 0x40)	? GPIO06_Level		= 1	: GPIO06_Level		= 0;
	(Direction	& 0x80)	? GPIO08_DIRECTION	= 1 : GPIO08_DIRECTION	= 0;
	(Level		& 0x80)	? GPIO07_Level		= 1	: GPIO07_Level		= 0;
	
	Ret = EApiGPIOGetSerialCfg(&Val_GPIO_SERIAL_MODE);
	if(Ret != EAPI_STATUS_SUCCESS) MessageBox(TEXT("EApiGPIO_SECO_GetSerialCfg Error"), 0, 0);

	switch(Val_GPIO_SERIAL_MODE)
	{
		case GPIO_SERIAL_MODE_RS232:
			m_GPIO_Serial = 0;
			break;
		case GPIO_SERIAL_MODE_RS422:
			m_GPIO_Serial = 1;
			break;
		case GPIO_SERIAL_MODE_RS485TX:
			m_GPIO_Serial = 2;
			break;
		case GPIO_SERIAL_MODE_RS485RX:
			m_GPIO_Serial = 3;
			break;
		default:
			break;
	}

	UpdateData(false);

	GetDlgItem(IDC_PITX_NONE)->EnableWindow(FALSE);
	GetDlgItem(IDC_PITX_799)->EnableWindow(FALSE);
	GetDlgItem(IDC_0A42)->EnableWindow(FALSE);
	GetDlgItem(IDC_0A19)->EnableWindow(FALSE);
}

void CEAPI_ExeDlg::OnBnClickedCarrA19()
{
	EApiStatus_t Ret;
	uint32_t		Bitmask		= 0x000000FF;
	uint32_t		Direction;
	uint32_t		Level;
	uint32_t		Inputs, Outputs;

	m_CarrierBoard = CARRIER_0A19;

	EApiSetCarrier(m_CarrierBoard);

	UpdateData(true);

	if(EApiGPIOGetDirectionCaps(EAPI_ID_GPIO_BANK00, &Inputs, &Outputs) == EAPI_STATUS_SUCCESS)
	{
		if((Inputs & 0x01) && (Outputs & 0x01))GetDlgItem(IDC_DIRECTION_GPIO01)->EnableWindow(TRUE);
		if((Inputs & 0x02) && (Outputs & 0x02))GetDlgItem(IDC_DIRECTION_GPIO02)->EnableWindow(TRUE);
		if((Inputs & 0x04) && (Outputs & 0x04))GetDlgItem(IDC_DIRECTION_GPIO03)->EnableWindow(TRUE);
		if((Inputs & 0x08) && (Outputs & 0x08))GetDlgItem(IDC_DIRECTION_GPIO04)->EnableWindow(TRUE);
		if((Inputs & 0x10) && (Outputs & 0x10))GetDlgItem(IDC_DIRECTION_GPIO05)->EnableWindow(TRUE);
		if((Inputs & 0x20) && (Outputs & 0x20))GetDlgItem(IDC_DIRECTION_GPIO06)->EnableWindow(TRUE);
		if((Inputs & 0x40) && (Outputs & 0x40))GetDlgItem(IDC_DIRECTION_GPIO07)->EnableWindow(TRUE);
		if((Inputs & 0x80) && (Outputs & 0x80))GetDlgItem(IDC_DIRECTION_GPIO08)->EnableWindow(TRUE);
	}
	else 
		return;

	// ---------------------------------- GPIO ---------------------------------------

	Ret = EApiGPIOGetDirection(EAPI_ID_GPIO_BANK00, Bitmask, &Direction);
	if(Ret != EAPI_STATUS_SUCCESS) MessageBox(TEXT("EApiGPIO_SECO_GetDirection Error"), 0, 0);
	Ret = EApiGPIOGetLevel(EAPI_ID_GPIO_BANK00, Bitmask, &Level);
	if(Ret != EAPI_STATUS_SUCCESS) MessageBox(TEXT("EApiGPIO_SECO_GetLevel Error"), 0, 0);

	if(Direction & 0x01)GetDlgItem(IDC_LEVEL_GPIO01)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO01)->EnableWindow(TRUE);
	if(Direction & 0x02)GetDlgItem(IDC_LEVEL_GPIO02)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO02)->EnableWindow(TRUE);
	if(Direction & 0x04)GetDlgItem(IDC_LEVEL_GPIO03)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO03)->EnableWindow(TRUE);
	if(Direction & 0x08)GetDlgItem(IDC_LEVEL_GPIO04)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO04)->EnableWindow(TRUE);
	if(Direction & 0x10)GetDlgItem(IDC_LEVEL_GPIO05)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO05)->EnableWindow(TRUE);
	if(Direction & 0x20)GetDlgItem(IDC_LEVEL_GPIO06)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO06)->EnableWindow(TRUE);
	if(Direction & 0x40)GetDlgItem(IDC_LEVEL_GPIO07)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO07)->EnableWindow(TRUE);
	if(Direction & 0x80)GetDlgItem(IDC_LEVEL_GPIO08)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO08)->EnableWindow(TRUE);

	(Direction	& 0x01)	? GPIO01_DIRECTION	= 1 : GPIO01_DIRECTION	= 0;
	(Level		& 0x01)	? GPIO00_Level		= 1	: GPIO00_Level		= 0;
	(Direction	& 0x02)	? GPIO02_DIRECTION	= 1 : GPIO02_DIRECTION	= 0;
	(Level		& 0x02)	? GPIO01_Level		= 1	: GPIO01_Level		= 0;
	(Direction	& 0x04)	? GPIO03_DIRECTION	= 1 : GPIO03_DIRECTION	= 0;
	(Level		& 0x04)	? GPIO02_Level		= 1	: GPIO02_Level		= 0;
	(Direction	& 0x08)	? GPIO04_DIRECTION	= 1 : GPIO04_DIRECTION	= 0;
	(Level		& 0x08)	? GPIO03_Level		= 1	: GPIO03_Level		= 0;
	(Direction	& 0x10)	? GPIO05_DIRECTION	= 1 : GPIO05_DIRECTION	= 0;
	(Level		& 0x10)	? GPIO04_Level		= 1	: GPIO04_Level		= 0;
	(Direction	& 0x20)	? GPIO06_DIRECTION	= 1 : GPIO06_DIRECTION	= 0;
	(Level		& 0x20)	? GPIO05_Level		= 1	: GPIO05_Level		= 0;
	(Direction	& 0x40)	? GPIO07_DIRECTION	= 1 : GPIO07_DIRECTION	= 0;
	(Level		& 0x40)	? GPIO06_Level		= 1	: GPIO06_Level		= 0;
	(Direction	& 0x80)	? GPIO08_DIRECTION	= 1 : GPIO08_DIRECTION	= 0;
	(Level		& 0x80)	? GPIO07_Level		= 1	: GPIO07_Level		= 0;
	
	UpdateData(false);

	GetDlgItem(IDC_PITX_NONE)->EnableWindow(FALSE);
	GetDlgItem(IDC_PITX_799)->EnableWindow(FALSE);
	GetDlgItem(IDC_PITX_901)->EnableWindow(FALSE);
}

void CEAPI_ExeDlg::OnBnClickedCarrA42()
{
	EApiStatus_t Ret;
	uint32_t		Bitmask		= 0x000000FF;
	uint32_t		Direction;
	uint32_t		Level;
	uint32_t		Inputs, Outputs;

	m_CarrierBoard = CARRIER_0A42;

	EApiSetCarrier(m_CarrierBoard);

	UpdateData(true);

	if(EApiGPIOGetDirectionCaps(EAPI_ID_GPIO_BANK00, &Inputs, &Outputs) == EAPI_STATUS_SUCCESS)
	{
		if((Inputs & 0x01) && (Outputs & 0x01))GetDlgItem(IDC_DIRECTION_GPIO01)->EnableWindow(TRUE);
		if((Inputs & 0x02) && (Outputs & 0x02))GetDlgItem(IDC_DIRECTION_GPIO02)->EnableWindow(TRUE);
		if((Inputs & 0x04) && (Outputs & 0x04))GetDlgItem(IDC_DIRECTION_GPIO03)->EnableWindow(TRUE);
		if((Inputs & 0x08) && (Outputs & 0x08))GetDlgItem(IDC_DIRECTION_GPIO04)->EnableWindow(TRUE);
		if((Inputs & 0x10) && (Outputs & 0x10))GetDlgItem(IDC_DIRECTION_GPIO05)->EnableWindow(TRUE);
		if((Inputs & 0x20) && (Outputs & 0x20))GetDlgItem(IDC_DIRECTION_GPIO06)->EnableWindow(TRUE);
		if((Inputs & 0x40) && (Outputs & 0x40))GetDlgItem(IDC_DIRECTION_GPIO07)->EnableWindow(TRUE);
		if((Inputs & 0x80) && (Outputs & 0x80))GetDlgItem(IDC_DIRECTION_GPIO08)->EnableWindow(TRUE);
	}
	else 
		return;

	// ---------------------------------- GPIO ---------------------------------------

	Ret = EApiGPIOGetDirection(EAPI_ID_GPIO_BANK00, Bitmask, &Direction);
	if(Ret != EAPI_STATUS_SUCCESS) MessageBox(TEXT("EApiGPIO_SECO_GetDirection Error"), 0, 0);
	Ret = EApiGPIOGetLevel(EAPI_ID_GPIO_BANK00, Bitmask, &Level);
	if(Ret != EAPI_STATUS_SUCCESS) MessageBox(TEXT("EApiGPIO_SECO_GetLevel Error"), 0, 0);

	if(Direction & 0x01)GetDlgItem(IDC_LEVEL_GPIO01)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO01)->EnableWindow(TRUE);
	if(Direction & 0x02)GetDlgItem(IDC_LEVEL_GPIO02)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO02)->EnableWindow(TRUE);
	if(Direction & 0x04)GetDlgItem(IDC_LEVEL_GPIO03)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO03)->EnableWindow(TRUE);
	if(Direction & 0x08)GetDlgItem(IDC_LEVEL_GPIO04)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO04)->EnableWindow(TRUE);
	if(Direction & 0x10)GetDlgItem(IDC_LEVEL_GPIO05)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO05)->EnableWindow(TRUE);
	if(Direction & 0x20)GetDlgItem(IDC_LEVEL_GPIO06)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO06)->EnableWindow(TRUE);
	if(Direction & 0x40)GetDlgItem(IDC_LEVEL_GPIO07)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO07)->EnableWindow(TRUE);
	if(Direction & 0x80)GetDlgItem(IDC_LEVEL_GPIO08)->EnableWindow(FALSE); else GetDlgItem(IDC_LEVEL_GPIO08)->EnableWindow(TRUE);

	(Direction	& 0x01)	? GPIO01_DIRECTION	= 1 : GPIO01_DIRECTION	= 0;
	(Level		& 0x01)	? GPIO00_Level		= 1	: GPIO00_Level		= 0;
	(Direction	& 0x02)	? GPIO02_DIRECTION	= 1 : GPIO02_DIRECTION	= 0;
	(Level		& 0x02)	? GPIO01_Level		= 1	: GPIO01_Level		= 0;
	(Direction	& 0x04)	? GPIO03_DIRECTION	= 1 : GPIO03_DIRECTION	= 0;
	(Level		& 0x04)	? GPIO02_Level		= 1	: GPIO02_Level		= 0;
	(Direction	& 0x08)	? GPIO04_DIRECTION	= 1 : GPIO04_DIRECTION	= 0;
	(Level		& 0x08)	? GPIO03_Level		= 1	: GPIO03_Level		= 0;
	(Direction	& 0x10)	? GPIO05_DIRECTION	= 1 : GPIO05_DIRECTION	= 0;
	(Level		& 0x10)	? GPIO04_Level		= 1	: GPIO04_Level		= 0;
	(Direction	& 0x20)	? GPIO06_DIRECTION	= 1 : GPIO06_DIRECTION	= 0;
	(Level		& 0x20)	? GPIO05_Level		= 1	: GPIO05_Level		= 0;
	(Direction	& 0x40)	? GPIO07_DIRECTION	= 1 : GPIO07_DIRECTION	= 0;
	(Level		& 0x40)	? GPIO06_Level		= 1	: GPIO06_Level		= 0;
	(Direction	& 0x80)	? GPIO08_DIRECTION	= 1 : GPIO08_DIRECTION	= 0;
	(Level		& 0x80)	? GPIO07_Level		= 1	: GPIO07_Level		= 0;
	
	UpdateData(false);

	GetDlgItem(IDC_PITX_NONE)->EnableWindow(FALSE);
	GetDlgItem(IDC_PITX_799)->EnableWindow(FALSE);
	GetDlgItem(IDC_PITX_901)->EnableWindow(FALSE);
	GetDlgItem(IDC_0A19)->EnableWindow(FALSE);
}
void CEAPI_ExeDlg::OnBnClickedGpioRefresh()
{
	uint32_t		Bitmask		= 0x000000FF;
	uint32_t		Level;

	if(EApiGPIOGetLevel(EAPI_ID_GPIO_BANK00, Bitmask, &Level) == EAPI_STATUS_SUCCESS)
	{
		(Level & 0x01)	?	GPIO00_Level = 1	: GPIO00_Level = 0;
		(Level & 0x02)	?	GPIO01_Level = 1	: GPIO01_Level = 0;
		(Level & 0x04)	?	GPIO02_Level = 1	: GPIO02_Level = 0;
		(Level & 0x08)	?	GPIO03_Level = 1	: GPIO03_Level = 0;
		(Level & 0x10)	?	GPIO04_Level = 1	: GPIO04_Level = 0;
		(Level & 0x20)	?	GPIO05_Level = 1	: GPIO05_Level = 0;
		(Level & 0x40)	?	GPIO06_Level = 1	: GPIO06_Level = 0;
		(Level & 0x80)	?	GPIO07_Level = 1	: GPIO07_Level = 0;

		UpdateData(false);
	}
}

void CEAPI_ExeDlg::OnBnClickedEnableWDTCustom()
{
	uint32_t mode_Event;
	uint8_t mode_Trigger_Type;

	UpdateData(true);

	switch(m_WDT_Mode)
	{
		case 0:
			mode_Event = EAPI_WTD_MODE_SYSTEM_RESET;
			break;
		case 1:
			mode_Event = EAPI_WTD_MODE_PWRBTN_1SEC;
			break;
		case 2:
			mode_Event = EAPI_WTD_MODE_PWRBTN_4SEC;
			break;
		case 3:
			mode_Event = EAPI_WTD_MODE_SIGNAL;
			break;
		default:
			MessageBox(TEXT("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			return;
			break;
	}

	switch(m_Trigger_SW_HW)
	{
		case 0:
			mode_Trigger_Type = EAPI_WTD_MODE_ENABLE_SW_TRIGGER;
			break;
		case 1:
			mode_Trigger_Type = EAPI_WTD_MODE_ENABLE_HW_TRIGGER;
			break;
		default:
			MessageBox(TEXT("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			return;
			break;
	}
	
	switch(EApiWDog_SetConfigAndStart(	m_Delay, 
										m_Event, 
										m_Reset, 
										mode_Event, 
										EAPI_WTD_MODE_IN_MSEC, 
										EAPI_WTD_MODE_IN_MSEC, 
										mode_Trigger_Type))
	{
		case EAPI_STATUS_SUCCESS:
			GetDlgItem(IDC_ENABLE_WDT)->EnableWindow(FALSE);
			GetDlgItem(IDC_ENABLE_WDT_CUSTOM)->EnableWindow(FALSE);
			GetDlgItem(IDC_DISABLE_WDT)->EnableWindow(TRUE);
			break;
		case EAPI_STATUS_NOT_INITIALIZED:
			MessageBox(TEXT("EAPI_STATUS_NOT_INITIALIZED"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_RUNNING:
			MessageBox(TEXT("EAPI_STATUS_RUNNING"), 0, 0);
			break;
		case EAPI_STATUS_INVALID_PARAMETER:
			MessageBox(TEXT("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			break;
		case EAPI_STATUS_ERROR:
		default:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
	}

	return;
}