// EAPI_WINCEDlg.h : header file
//

#pragma once
#include "afxwin.h"

#define LEN_MAX_BYTE_BUFFER 256


// CEAPI_ExeDlg dialog
class CEAPI_ExeDlg : public CDialog
{
// Construction
public:
	CEAPI_ExeDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_EAPI_WINCE_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
#endif

	static DWORD WINAPI ThreadProc_Trigger(LPVOID lpParameter);
	static DWORD WINAPI ThreadProc_Monitor(LPVOID lpParameter);

	DECLARE_MESSAGE_MAP()
public:

	HANDLE	hTrigger;
	int m_Timeout_Expressed;
	int m_Delay_Expressed;
	int m_WDT_Mode;
	int m_Trigger_SW_HW;
	int m_GPIO_Serial;
	int m_pITX_Carrier;
	int m_I2C_Mode;
	DWORD m_Reset;
	DWORD m_Delay;	
	DWORD m_Event;
	UINT m_Fan_Cycle;
	BYTE m_Fan_Duty;
	BYTE m_Storage_num_byte_to_read;
	CStatic m_Library_Rev;
	CStatic m_Manufacturer;
	CStatic m_Product_Name;
	CStatic m_Serial_Number;
	CStatic m_Boot_Conter;
	CStatic m_Bios_revision;
	CStatic m_Platform_Rev;	
	CStatic m_Platform_type;	
	CStatic m_HW_revision;	
	CStatic m_Spec_version;
	CStatic m_Temperature1;
	CStatic m_Temperature2;
	CStatic m_Fan_RPM;
	CStatic m_Fan_RPM2;
	CStatic m_label_backlight;
	CString m_Data_String;
	CString m_DevAdd_String;
	CString m_Reg_String;


	CString m_NVS_Data;
	CString m_NVS_Address;
	CSliderCtrl m_slider_backlight;

	CStatic m_VCore_Voltage;
	CStatic m_2V5_Voltage;
	CStatic m_3V3_Voltage;
	CStatic m_VBat_Voltage;
	CStatic m_5V_Voltage;
	CStatic m_5VSB_Voltage;
	CStatic m_12V_Voltage;

	BOOL GPIO00_Level;
	BOOL GPIO01_Level;
	BOOL GPIO02_Level;
	BOOL GPIO03_Level;
	BOOL GPIO04_Level;
	BOOL GPIO05_Level;
	BOOL GPIO06_Level;
	BOOL GPIO07_Level;
	BOOL GPIO01_DIRECTION;
	BOOL GPIO02_DIRECTION;
	BOOL GPIO03_DIRECTION;
	BOOL GPIO04_DIRECTION;
	BOOL GPIO05_DIRECTION;
	BOOL GPIO06_DIRECTION;
	BOOL GPIO07_DIRECTION;
	BOOL GPIO08_DIRECTION;

	BOOL m_BKL_Enable;	

	unsigned char m_CarrierBoard; 

	bool HexStringToUnsignedChar(CString HexString, unsigned char * Buffer, unsigned long * LenBufferFind);
	bool HexWordStringToUnsignedShort(CString HexString, unsigned short * Buffer);
	bool HexDWordStringToUnsignedLong(CString HexString, unsigned long * Buffer);
	bool HexToDec(CString HexString, unsigned char * Buff);
	bool HexByteString2UnsignedChar(CString HexByteString, unsigned char * UnsignedCharReturned);

	afx_msg void OnBnClickedEnableWdt();
	afx_msg void OnBnClickedStartTrig();
	afx_msg void OnBnClickedDisableWdt();
	afx_msg void OnBnClickedStopTrig();
	afx_msg void OnBnClickedI2cReadReg();
	afx_msg void OnBnClickedI2cWriteReg();
	afx_msg void OnBnClickedI2cRead();
	afx_msg void OnBnClickedI2cWrite();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBnClickedEnableFAN();
	afx_msg void OnBnClickedDisableFAN();
	afx_msg void OnBnClickedSetCycle();
	afx_msg void OnBnClickedSetDutyCycle();
	afx_msg void OnBnClickedGetCycle();
	afx_msg void OnBnClickedGetDutyCycle();
	afx_msg void OnBnClickedGPIO01();
	afx_msg void OnBnClickedGPIO02();
	afx_msg void OnBnClickedGPIO03();
	afx_msg void OnBnClickedGPIO04();
	afx_msg void OnBnClickedGPIO17();
	afx_msg void OnBnClickedGPIO20();
	afx_msg void OnBnClickedGPIO21();
	afx_msg void OnBnClickedGPIO22();
	afx_msg void OnBnClickedCheck11();
	afx_msg void OnBnClickedCheck12();
	afx_msg void OnBnClickedCheck13();
	afx_msg void OnBnClickedCheck14();
	afx_msg void OnBnClickedCheck15();
	afx_msg void OnBnClickedCheck16();
	afx_msg void OnBnClickedCheck17();
	afx_msg void OnBnClickedCheck18();
	afx_msg void OnBnClicked_NVS_Write();
	afx_msg void OnBnClicked_NVS_Read();
	afx_msg void OnBnClickedRadio10();
	afx_msg void OnBnClickedRadio15();
	afx_msg void OnBnClickedRadio16();
	afx_msg void OnBnClickedRadio17();
	afx_msg void OnBnClickedRadio5();
	afx_msg void OnBnClickedBacklEna();
	afx_msg void OnBnClickedPitxNone();
	afx_msg void OnBnClickedPitx799();
	afx_msg void OnBnClickedPitx901();
	afx_msg void OnBnClickedCarrA42();
	afx_msg void OnBnClickedCarrA19();
	afx_msg void OnBnClickedGpioRefresh();
	afx_msg void OnBnClickedEnableWDTCustom();
};
